import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BgpvpnNetworkAssociateV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_network_associate_v2#bgpvpn_id BgpvpnNetworkAssociateV2#bgpvpn_id}
    */
    readonly bgpvpnId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_network_associate_v2#id BgpvpnNetworkAssociateV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_network_associate_v2#network_id BgpvpnNetworkAssociateV2#network_id}
    */
    readonly networkId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_network_associate_v2#project_id BgpvpnNetworkAssociateV2#project_id}
    */
    readonly projectId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_network_associate_v2#region BgpvpnNetworkAssociateV2#region}
    */
    readonly region?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_network_associate_v2 openstack_bgpvpn_network_associate_v2}
*/
export declare class BgpvpnNetworkAssociateV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_bgpvpn_network_associate_v2";
    /**
    * Generates CDKTF code for importing a BgpvpnNetworkAssociateV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BgpvpnNetworkAssociateV2 to import
    * @param importFromId The id of the existing BgpvpnNetworkAssociateV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_network_associate_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BgpvpnNetworkAssociateV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_network_associate_v2 openstack_bgpvpn_network_associate_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BgpvpnNetworkAssociateV2Config
    */
    constructor(scope: Construct, id: string, config: BgpvpnNetworkAssociateV2Config);
    private _bgpvpnId?;
    get bgpvpnId(): string;
    set bgpvpnId(value: string);
    get bgpvpnIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    get networkIdInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    resetProjectId(): void;
    get projectIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
