import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BgpvpnPortAssociateV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#advertise_fixed_ips BgpvpnPortAssociateV2#advertise_fixed_ips}
    */
    readonly advertiseFixedIps?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#bgpvpn_id BgpvpnPortAssociateV2#bgpvpn_id}
    */
    readonly bgpvpnId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#id BgpvpnPortAssociateV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#port_id BgpvpnPortAssociateV2#port_id}
    */
    readonly portId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#project_id BgpvpnPortAssociateV2#project_id}
    */
    readonly projectId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#region BgpvpnPortAssociateV2#region}
    */
    readonly region?: string;
    /**
    * routes block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#routes BgpvpnPortAssociateV2#routes}
    */
    readonly routes?: BgpvpnPortAssociateV2Routes[] | cdktf.IResolvable;
}
export interface BgpvpnPortAssociateV2Routes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#bgpvpn_id BgpvpnPortAssociateV2#bgpvpn_id}
    */
    readonly bgpvpnId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#local_pref BgpvpnPortAssociateV2#local_pref}
    */
    readonly localPref?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#prefix BgpvpnPortAssociateV2#prefix}
    */
    readonly prefix?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#type BgpvpnPortAssociateV2#type}
    */
    readonly type: string;
}
export declare function bgpvpnPortAssociateV2RoutesToTerraform(struct?: BgpvpnPortAssociateV2Routes | cdktf.IResolvable): any;
export declare function bgpvpnPortAssociateV2RoutesToHclTerraform(struct?: BgpvpnPortAssociateV2Routes | cdktf.IResolvable): any;
export declare class BgpvpnPortAssociateV2RoutesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): BgpvpnPortAssociateV2Routes | cdktf.IResolvable | undefined;
    set internalValue(value: BgpvpnPortAssociateV2Routes | cdktf.IResolvable | undefined);
    private _bgpvpnId?;
    get bgpvpnId(): string;
    set bgpvpnId(value: string);
    resetBgpvpnId(): void;
    get bgpvpnIdInput(): string | undefined;
    private _localPref?;
    get localPref(): number;
    set localPref(value: number);
    resetLocalPref(): void;
    get localPrefInput(): number | undefined;
    private _prefix?;
    get prefix(): string;
    set prefix(value: string);
    resetPrefix(): void;
    get prefixInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class BgpvpnPortAssociateV2RoutesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: BgpvpnPortAssociateV2Routes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): BgpvpnPortAssociateV2RoutesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2 openstack_bgpvpn_port_associate_v2}
*/
export declare class BgpvpnPortAssociateV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_bgpvpn_port_associate_v2";
    /**
    * Generates CDKTF code for importing a BgpvpnPortAssociateV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BgpvpnPortAssociateV2 to import
    * @param importFromId The id of the existing BgpvpnPortAssociateV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BgpvpnPortAssociateV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_port_associate_v2 openstack_bgpvpn_port_associate_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BgpvpnPortAssociateV2Config
    */
    constructor(scope: Construct, id: string, config: BgpvpnPortAssociateV2Config);
    private _advertiseFixedIps?;
    get advertiseFixedIps(): boolean | cdktf.IResolvable;
    set advertiseFixedIps(value: boolean | cdktf.IResolvable);
    resetAdvertiseFixedIps(): void;
    get advertiseFixedIpsInput(): boolean | cdktf.IResolvable | undefined;
    private _bgpvpnId?;
    get bgpvpnId(): string;
    set bgpvpnId(value: string);
    get bgpvpnIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _portId?;
    get portId(): string;
    set portId(value: string);
    get portIdInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    resetProjectId(): void;
    get projectIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _routes;
    get routes(): BgpvpnPortAssociateV2RoutesList;
    putRoutes(value: BgpvpnPortAssociateV2Routes[] | cdktf.IResolvable): void;
    resetRoutes(): void;
    get routesInput(): cdktf.IResolvable | BgpvpnPortAssociateV2Routes[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
