import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BgpvpnV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#export_targets BgpvpnV2#export_targets}
    */
    readonly exportTargets?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#id BgpvpnV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#import_targets BgpvpnV2#import_targets}
    */
    readonly importTargets?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#local_pref BgpvpnV2#local_pref}
    */
    readonly localPref?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#name BgpvpnV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#project_id BgpvpnV2#project_id}
    */
    readonly projectId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#region BgpvpnV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#route_distinguishers BgpvpnV2#route_distinguishers}
    */
    readonly routeDistinguishers?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#route_targets BgpvpnV2#route_targets}
    */
    readonly routeTargets?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#type BgpvpnV2#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#vni BgpvpnV2#vni}
    */
    readonly vni?: number;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#timeouts BgpvpnV2#timeouts}
    */
    readonly timeouts?: BgpvpnV2Timeouts;
}
export interface BgpvpnV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#create BgpvpnV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#delete BgpvpnV2#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#update BgpvpnV2#update}
    */
    readonly update?: string;
}
export declare function bgpvpnV2TimeoutsToTerraform(struct?: BgpvpnV2Timeouts | cdktf.IResolvable): any;
export declare function bgpvpnV2TimeoutsToHclTerraform(struct?: BgpvpnV2Timeouts | cdktf.IResolvable): any;
export declare class BgpvpnV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): BgpvpnV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: BgpvpnV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2 openstack_bgpvpn_v2}
*/
export declare class BgpvpnV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_bgpvpn_v2";
    /**
    * Generates CDKTF code for importing a BgpvpnV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BgpvpnV2 to import
    * @param importFromId The id of the existing BgpvpnV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BgpvpnV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/bgpvpn_v2 openstack_bgpvpn_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BgpvpnV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: BgpvpnV2Config);
    private _exportTargets?;
    get exportTargets(): string[];
    set exportTargets(value: string[]);
    resetExportTargets(): void;
    get exportTargetsInput(): string[] | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _importTargets?;
    get importTargets(): string[];
    set importTargets(value: string[]);
    resetImportTargets(): void;
    get importTargetsInput(): string[] | undefined;
    private _localPref?;
    get localPref(): number;
    set localPref(value: number);
    resetLocalPref(): void;
    get localPrefInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networks(): string[];
    get ports(): string[];
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    resetProjectId(): void;
    get projectIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _routeDistinguishers?;
    get routeDistinguishers(): string[];
    set routeDistinguishers(value: string[]);
    resetRouteDistinguishers(): void;
    get routeDistinguishersInput(): string[] | undefined;
    private _routeTargets?;
    get routeTargets(): string[];
    set routeTargets(value: string[]);
    resetRouteTargets(): void;
    get routeTargetsInput(): string[] | undefined;
    get routers(): string[];
    get shared(): cdktf.IResolvable;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _vni?;
    get vni(): number;
    set vni(value: number);
    resetVni(): void;
    get vniInput(): number | undefined;
    private _timeouts;
    get timeouts(): BgpvpnV2TimeoutsOutputReference;
    putTimeouts(value: BgpvpnV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | BgpvpnV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
