import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BlockstorageQosAssociationV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_association_v3#id BlockstorageQosAssociationV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_association_v3#qos_id BlockstorageQosAssociationV3#qos_id}
    */
    readonly qosId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_association_v3#region BlockstorageQosAssociationV3#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_association_v3#volume_type_id BlockstorageQosAssociationV3#volume_type_id}
    */
    readonly volumeTypeId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_association_v3 openstack_blockstorage_qos_association_v3}
*/
export declare class BlockstorageQosAssociationV3 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_blockstorage_qos_association_v3";
    /**
    * Generates CDKTF code for importing a BlockstorageQosAssociationV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BlockstorageQosAssociationV3 to import
    * @param importFromId The id of the existing BlockstorageQosAssociationV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_association_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BlockstorageQosAssociationV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_association_v3 openstack_blockstorage_qos_association_v3} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BlockstorageQosAssociationV3Config
    */
    constructor(scope: Construct, id: string, config: BlockstorageQosAssociationV3Config);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _qosId?;
    get qosId(): string;
    set qosId(value: string);
    get qosIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _volumeTypeId?;
    get volumeTypeId(): string;
    set volumeTypeId(value: string);
    get volumeTypeIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
