import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BlockstorageQosV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_v3#consumer BlockstorageQosV3#consumer}
    */
    readonly consumer?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_v3#id BlockstorageQosV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_v3#name BlockstorageQosV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_v3#region BlockstorageQosV3#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_v3#specs BlockstorageQosV3#specs}
    */
    readonly specs?: {
        [key: string]: string;
    };
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_v3 openstack_blockstorage_qos_v3}
*/
export declare class BlockstorageQosV3 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_blockstorage_qos_v3";
    /**
    * Generates CDKTF code for importing a BlockstorageQosV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BlockstorageQosV3 to import
    * @param importFromId The id of the existing BlockstorageQosV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BlockstorageQosV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_qos_v3 openstack_blockstorage_qos_v3} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BlockstorageQosV3Config
    */
    constructor(scope: Construct, id: string, config: BlockstorageQosV3Config);
    private _consumer?;
    get consumer(): string;
    set consumer(value: string);
    resetConsumer(): void;
    get consumerInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _specs?;
    get specs(): {
        [key: string]: string;
    };
    set specs(value: {
        [key: string]: string;
    });
    resetSpecs(): void;
    get specsInput(): {
        [key: string]: string;
    } | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
