import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BlockstorageQuotasetV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#backup_gigabytes BlockstorageQuotasetV3#backup_gigabytes}
    */
    readonly backupGigabytes?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#backups BlockstorageQuotasetV3#backups}
    */
    readonly backups?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#gigabytes BlockstorageQuotasetV3#gigabytes}
    */
    readonly gigabytes?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#groups BlockstorageQuotasetV3#groups}
    */
    readonly groups?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#id BlockstorageQuotasetV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#per_volume_gigabytes BlockstorageQuotasetV3#per_volume_gigabytes}
    */
    readonly perVolumeGigabytes?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#project_id BlockstorageQuotasetV3#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#region BlockstorageQuotasetV3#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#snapshots BlockstorageQuotasetV3#snapshots}
    */
    readonly snapshots?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#volume_type_quota BlockstorageQuotasetV3#volume_type_quota}
    */
    readonly volumeTypeQuota?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#volumes BlockstorageQuotasetV3#volumes}
    */
    readonly volumes?: number;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#timeouts BlockstorageQuotasetV3#timeouts}
    */
    readonly timeouts?: BlockstorageQuotasetV3Timeouts;
}
export interface BlockstorageQuotasetV3Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#create BlockstorageQuotasetV3#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#delete BlockstorageQuotasetV3#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#update BlockstorageQuotasetV3#update}
    */
    readonly update?: string;
}
export declare function blockstorageQuotasetV3TimeoutsToTerraform(struct?: BlockstorageQuotasetV3Timeouts | cdktf.IResolvable): any;
export declare function blockstorageQuotasetV3TimeoutsToHclTerraform(struct?: BlockstorageQuotasetV3Timeouts | cdktf.IResolvable): any;
export declare class BlockstorageQuotasetV3TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): BlockstorageQuotasetV3Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: BlockstorageQuotasetV3Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3 openstack_blockstorage_quotaset_v3}
*/
export declare class BlockstorageQuotasetV3 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_blockstorage_quotaset_v3";
    /**
    * Generates CDKTF code for importing a BlockstorageQuotasetV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BlockstorageQuotasetV3 to import
    * @param importFromId The id of the existing BlockstorageQuotasetV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BlockstorageQuotasetV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/blockstorage_quotaset_v3 openstack_blockstorage_quotaset_v3} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BlockstorageQuotasetV3Config
    */
    constructor(scope: Construct, id: string, config: BlockstorageQuotasetV3Config);
    private _backupGigabytes?;
    get backupGigabytes(): number;
    set backupGigabytes(value: number);
    resetBackupGigabytes(): void;
    get backupGigabytesInput(): number | undefined;
    private _backups?;
    get backups(): number;
    set backups(value: number);
    resetBackups(): void;
    get backupsInput(): number | undefined;
    private _gigabytes?;
    get gigabytes(): number;
    set gigabytes(value: number);
    resetGigabytes(): void;
    get gigabytesInput(): number | undefined;
    private _groups?;
    get groups(): number;
    set groups(value: number);
    resetGroups(): void;
    get groupsInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _perVolumeGigabytes?;
    get perVolumeGigabytes(): number;
    set perVolumeGigabytes(value: number);
    resetPerVolumeGigabytes(): void;
    get perVolumeGigabytesInput(): number | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _snapshots?;
    get snapshots(): number;
    set snapshots(value: number);
    resetSnapshots(): void;
    get snapshotsInput(): number | undefined;
    private _volumeTypeQuota?;
    get volumeTypeQuota(): {
        [key: string]: string;
    };
    set volumeTypeQuota(value: {
        [key: string]: string;
    });
    resetVolumeTypeQuota(): void;
    get volumeTypeQuotaInput(): {
        [key: string]: string;
    } | undefined;
    private _volumes?;
    get volumes(): number;
    set volumes(value: number);
    resetVolumes(): void;
    get volumesInput(): number | undefined;
    private _timeouts;
    get timeouts(): BlockstorageQuotasetV3TimeoutsOutputReference;
    putTimeouts(value: BlockstorageQuotasetV3Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | BlockstorageQuotasetV3Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
