import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ComputeFlavorV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#description ComputeFlavorV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#disk ComputeFlavorV2#disk}
    */
    readonly disk: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#ephemeral ComputeFlavorV2#ephemeral}
    */
    readonly ephemeral?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#extra_specs ComputeFlavorV2#extra_specs}
    */
    readonly extraSpecs?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#flavor_id ComputeFlavorV2#flavor_id}
    */
    readonly flavorId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#id ComputeFlavorV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#is_public ComputeFlavorV2#is_public}
    */
    readonly isPublic?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#name ComputeFlavorV2#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#ram ComputeFlavorV2#ram}
    */
    readonly ram: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#region ComputeFlavorV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#rx_tx_factor ComputeFlavorV2#rx_tx_factor}
    */
    readonly rxTxFactor?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#swap ComputeFlavorV2#swap}
    */
    readonly swap?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#vcpus ComputeFlavorV2#vcpus}
    */
    readonly vcpus: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2 openstack_compute_flavor_v2}
*/
export declare class ComputeFlavorV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_compute_flavor_v2";
    /**
    * Generates CDKTF code for importing a ComputeFlavorV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ComputeFlavorV2 to import
    * @param importFromId The id of the existing ComputeFlavorV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ComputeFlavorV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_flavor_v2 openstack_compute_flavor_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ComputeFlavorV2Config
    */
    constructor(scope: Construct, id: string, config: ComputeFlavorV2Config);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _disk?;
    get disk(): number;
    set disk(value: number);
    get diskInput(): number | undefined;
    private _ephemeral?;
    get ephemeral(): number;
    set ephemeral(value: number);
    resetEphemeral(): void;
    get ephemeralInput(): number | undefined;
    private _extraSpecs?;
    get extraSpecs(): {
        [key: string]: string;
    };
    set extraSpecs(value: {
        [key: string]: string;
    });
    resetExtraSpecs(): void;
    get extraSpecsInput(): {
        [key: string]: string;
    } | undefined;
    private _flavorId?;
    get flavorId(): string;
    set flavorId(value: string);
    resetFlavorId(): void;
    get flavorIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _isPublic?;
    get isPublic(): boolean | cdktf.IResolvable;
    set isPublic(value: boolean | cdktf.IResolvable);
    resetIsPublic(): void;
    get isPublicInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _ram?;
    get ram(): number;
    set ram(value: number);
    get ramInput(): number | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _rxTxFactor?;
    get rxTxFactor(): number;
    set rxTxFactor(value: number);
    resetRxTxFactor(): void;
    get rxTxFactorInput(): number | undefined;
    private _swap?;
    get swap(): number;
    set swap(value: number);
    resetSwap(): void;
    get swapInput(): number | undefined;
    private _vcpus?;
    get vcpus(): number;
    set vcpus(value: number);
    get vcpusInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
