import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ComputeQuotasetV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#cores ComputeQuotasetV2#cores}
    */
    readonly cores?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#fixed_ips ComputeQuotasetV2#fixed_ips}
    */
    readonly fixedIps?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#floating_ips ComputeQuotasetV2#floating_ips}
    */
    readonly floatingIps?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#id ComputeQuotasetV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#injected_file_content_bytes ComputeQuotasetV2#injected_file_content_bytes}
    */
    readonly injectedFileContentBytes?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#injected_file_path_bytes ComputeQuotasetV2#injected_file_path_bytes}
    */
    readonly injectedFilePathBytes?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#injected_files ComputeQuotasetV2#injected_files}
    */
    readonly injectedFiles?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#instances ComputeQuotasetV2#instances}
    */
    readonly instances?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#key_pairs ComputeQuotasetV2#key_pairs}
    */
    readonly keyPairs?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#metadata_items ComputeQuotasetV2#metadata_items}
    */
    readonly metadataItems?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#project_id ComputeQuotasetV2#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#ram ComputeQuotasetV2#ram}
    */
    readonly ram?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#region ComputeQuotasetV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#security_group_rules ComputeQuotasetV2#security_group_rules}
    */
    readonly securityGroupRules?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#security_groups ComputeQuotasetV2#security_groups}
    */
    readonly securityGroups?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#server_group_members ComputeQuotasetV2#server_group_members}
    */
    readonly serverGroupMembers?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#server_groups ComputeQuotasetV2#server_groups}
    */
    readonly serverGroups?: number;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#timeouts ComputeQuotasetV2#timeouts}
    */
    readonly timeouts?: ComputeQuotasetV2Timeouts;
}
export interface ComputeQuotasetV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#create ComputeQuotasetV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#delete ComputeQuotasetV2#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#update ComputeQuotasetV2#update}
    */
    readonly update?: string;
}
export declare function computeQuotasetV2TimeoutsToTerraform(struct?: ComputeQuotasetV2Timeouts | cdktf.IResolvable): any;
export declare function computeQuotasetV2TimeoutsToHclTerraform(struct?: ComputeQuotasetV2Timeouts | cdktf.IResolvable): any;
export declare class ComputeQuotasetV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeQuotasetV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeQuotasetV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2 openstack_compute_quotaset_v2}
*/
export declare class ComputeQuotasetV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_compute_quotaset_v2";
    /**
    * Generates CDKTF code for importing a ComputeQuotasetV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ComputeQuotasetV2 to import
    * @param importFromId The id of the existing ComputeQuotasetV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ComputeQuotasetV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_quotaset_v2 openstack_compute_quotaset_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ComputeQuotasetV2Config
    */
    constructor(scope: Construct, id: string, config: ComputeQuotasetV2Config);
    private _cores?;
    get cores(): number;
    set cores(value: number);
    resetCores(): void;
    get coresInput(): number | undefined;
    private _fixedIps?;
    get fixedIps(): number;
    set fixedIps(value: number);
    resetFixedIps(): void;
    get fixedIpsInput(): number | undefined;
    private _floatingIps?;
    get floatingIps(): number;
    set floatingIps(value: number);
    resetFloatingIps(): void;
    get floatingIpsInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _injectedFileContentBytes?;
    get injectedFileContentBytes(): number;
    set injectedFileContentBytes(value: number);
    resetInjectedFileContentBytes(): void;
    get injectedFileContentBytesInput(): number | undefined;
    private _injectedFilePathBytes?;
    get injectedFilePathBytes(): number;
    set injectedFilePathBytes(value: number);
    resetInjectedFilePathBytes(): void;
    get injectedFilePathBytesInput(): number | undefined;
    private _injectedFiles?;
    get injectedFiles(): number;
    set injectedFiles(value: number);
    resetInjectedFiles(): void;
    get injectedFilesInput(): number | undefined;
    private _instances?;
    get instances(): number;
    set instances(value: number);
    resetInstances(): void;
    get instancesInput(): number | undefined;
    private _keyPairs?;
    get keyPairs(): number;
    set keyPairs(value: number);
    resetKeyPairs(): void;
    get keyPairsInput(): number | undefined;
    private _metadataItems?;
    get metadataItems(): number;
    set metadataItems(value: number);
    resetMetadataItems(): void;
    get metadataItemsInput(): number | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _ram?;
    get ram(): number;
    set ram(value: number);
    resetRam(): void;
    get ramInput(): number | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _securityGroupRules?;
    get securityGroupRules(): number;
    set securityGroupRules(value: number);
    resetSecurityGroupRules(): void;
    get securityGroupRulesInput(): number | undefined;
    private _securityGroups?;
    get securityGroups(): number;
    set securityGroups(value: number);
    resetSecurityGroups(): void;
    get securityGroupsInput(): number | undefined;
    private _serverGroupMembers?;
    get serverGroupMembers(): number;
    set serverGroupMembers(value: number);
    resetServerGroupMembers(): void;
    get serverGroupMembersInput(): number | undefined;
    private _serverGroups?;
    get serverGroups(): number;
    set serverGroups(value: number);
    resetServerGroups(): void;
    get serverGroupsInput(): number | undefined;
    private _timeouts;
    get timeouts(): ComputeQuotasetV2TimeoutsOutputReference;
    putTimeouts(value: ComputeQuotasetV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | ComputeQuotasetV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
