import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ComputeServergroupV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_servergroup_v2#id ComputeServergroupV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_servergroup_v2#name ComputeServergroupV2#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_servergroup_v2#policies ComputeServergroupV2#policies}
    */
    readonly policies?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_servergroup_v2#region ComputeServergroupV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_servergroup_v2#value_specs ComputeServergroupV2#value_specs}
    */
    readonly valueSpecs?: {
        [key: string]: string;
    };
    /**
    * rules block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_servergroup_v2#rules ComputeServergroupV2#rules}
    */
    readonly rules?: ComputeServergroupV2Rules;
}
export interface ComputeServergroupV2Rules {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_servergroup_v2#max_server_per_host ComputeServergroupV2#max_server_per_host}
    */
    readonly maxServerPerHost?: number;
}
export declare function computeServergroupV2RulesToTerraform(struct?: ComputeServergroupV2RulesOutputReference | ComputeServergroupV2Rules): any;
export declare function computeServergroupV2RulesToHclTerraform(struct?: ComputeServergroupV2RulesOutputReference | ComputeServergroupV2Rules): any;
export declare class ComputeServergroupV2RulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeServergroupV2Rules | undefined;
    set internalValue(value: ComputeServergroupV2Rules | undefined);
    private _maxServerPerHost?;
    get maxServerPerHost(): number;
    set maxServerPerHost(value: number);
    resetMaxServerPerHost(): void;
    get maxServerPerHostInput(): number | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_servergroup_v2 openstack_compute_servergroup_v2}
*/
export declare class ComputeServergroupV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_compute_servergroup_v2";
    /**
    * Generates CDKTF code for importing a ComputeServergroupV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ComputeServergroupV2 to import
    * @param importFromId The id of the existing ComputeServergroupV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_servergroup_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ComputeServergroupV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/compute_servergroup_v2 openstack_compute_servergroup_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ComputeServergroupV2Config
    */
    constructor(scope: Construct, id: string, config: ComputeServergroupV2Config);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get members(): string[];
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _policies?;
    get policies(): string[];
    set policies(value: string[]);
    resetPolicies(): void;
    get policiesInput(): string[] | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _valueSpecs?;
    get valueSpecs(): {
        [key: string]: string;
    };
    set valueSpecs(value: {
        [key: string]: string;
    });
    resetValueSpecs(): void;
    get valueSpecsInput(): {
        [key: string]: string;
    } | undefined;
    private _rules;
    get rules(): ComputeServergroupV2RulesOutputReference;
    putRules(value: ComputeServergroupV2Rules): void;
    resetRules(): void;
    get rulesInput(): ComputeServergroupV2Rules | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
