import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ContainerinfraClusterV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#cluster_template_id ContainerinfraClusterV1#cluster_template_id}
    */
    readonly clusterTemplateId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#create_timeout ContainerinfraClusterV1#create_timeout}
    */
    readonly createTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#discovery_url ContainerinfraClusterV1#discovery_url}
    */
    readonly discoveryUrl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#docker_volume_size ContainerinfraClusterV1#docker_volume_size}
    */
    readonly dockerVolumeSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#fixed_network ContainerinfraClusterV1#fixed_network}
    */
    readonly fixedNetwork?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#fixed_subnet ContainerinfraClusterV1#fixed_subnet}
    */
    readonly fixedSubnet?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#flavor ContainerinfraClusterV1#flavor}
    */
    readonly flavor?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#floating_ip_enabled ContainerinfraClusterV1#floating_ip_enabled}
    */
    readonly floatingIpEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#id ContainerinfraClusterV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#keypair ContainerinfraClusterV1#keypair}
    */
    readonly keypair?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#labels ContainerinfraClusterV1#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#master_count ContainerinfraClusterV1#master_count}
    */
    readonly masterCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#master_flavor ContainerinfraClusterV1#master_flavor}
    */
    readonly masterFlavor?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#master_lb_enabled ContainerinfraClusterV1#master_lb_enabled}
    */
    readonly masterLbEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#merge_labels ContainerinfraClusterV1#merge_labels}
    */
    readonly mergeLabels?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#name ContainerinfraClusterV1#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#node_count ContainerinfraClusterV1#node_count}
    */
    readonly nodeCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#region ContainerinfraClusterV1#region}
    */
    readonly region?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#timeouts ContainerinfraClusterV1#timeouts}
    */
    readonly timeouts?: ContainerinfraClusterV1Timeouts;
}
export interface ContainerinfraClusterV1Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#create ContainerinfraClusterV1#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#delete ContainerinfraClusterV1#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#update ContainerinfraClusterV1#update}
    */
    readonly update?: string;
}
export declare function containerinfraClusterV1TimeoutsToTerraform(struct?: ContainerinfraClusterV1Timeouts | cdktf.IResolvable): any;
export declare function containerinfraClusterV1TimeoutsToHclTerraform(struct?: ContainerinfraClusterV1Timeouts | cdktf.IResolvable): any;
export declare class ContainerinfraClusterV1TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ContainerinfraClusterV1Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: ContainerinfraClusterV1Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1 openstack_containerinfra_cluster_v1}
*/
export declare class ContainerinfraClusterV1 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_containerinfra_cluster_v1";
    /**
    * Generates CDKTF code for importing a ContainerinfraClusterV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ContainerinfraClusterV1 to import
    * @param importFromId The id of the existing ContainerinfraClusterV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ContainerinfraClusterV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_cluster_v1 openstack_containerinfra_cluster_v1} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ContainerinfraClusterV1Config
    */
    constructor(scope: Construct, id: string, config: ContainerinfraClusterV1Config);
    get apiAddress(): string;
    private _clusterTemplateId?;
    get clusterTemplateId(): string;
    set clusterTemplateId(value: string);
    get clusterTemplateIdInput(): string | undefined;
    get coeVersion(): string;
    get containerVersion(): string;
    private _createTimeout?;
    get createTimeout(): number;
    set createTimeout(value: number);
    resetCreateTimeout(): void;
    get createTimeoutInput(): number | undefined;
    get createdAt(): string;
    private _discoveryUrl?;
    get discoveryUrl(): string;
    set discoveryUrl(value: string);
    resetDiscoveryUrl(): void;
    get discoveryUrlInput(): string | undefined;
    private _dockerVolumeSize?;
    get dockerVolumeSize(): number;
    set dockerVolumeSize(value: number);
    resetDockerVolumeSize(): void;
    get dockerVolumeSizeInput(): number | undefined;
    private _fixedNetwork?;
    get fixedNetwork(): string;
    set fixedNetwork(value: string);
    resetFixedNetwork(): void;
    get fixedNetworkInput(): string | undefined;
    private _fixedSubnet?;
    get fixedSubnet(): string;
    set fixedSubnet(value: string);
    resetFixedSubnet(): void;
    get fixedSubnetInput(): string | undefined;
    private _flavor?;
    get flavor(): string;
    set flavor(value: string);
    resetFlavor(): void;
    get flavorInput(): string | undefined;
    private _floatingIpEnabled?;
    get floatingIpEnabled(): boolean | cdktf.IResolvable;
    set floatingIpEnabled(value: boolean | cdktf.IResolvable);
    resetFloatingIpEnabled(): void;
    get floatingIpEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _keypair?;
    get keypair(): string;
    set keypair(value: string);
    resetKeypair(): void;
    get keypairInput(): string | undefined;
    private _kubeconfig;
    get kubeconfig(): cdktf.StringMap;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    get masterAddresses(): string[];
    private _masterCount?;
    get masterCount(): number;
    set masterCount(value: number);
    resetMasterCount(): void;
    get masterCountInput(): number | undefined;
    private _masterFlavor?;
    get masterFlavor(): string;
    set masterFlavor(value: string);
    resetMasterFlavor(): void;
    get masterFlavorInput(): string | undefined;
    private _masterLbEnabled?;
    get masterLbEnabled(): boolean | cdktf.IResolvable;
    set masterLbEnabled(value: boolean | cdktf.IResolvable);
    resetMasterLbEnabled(): void;
    get masterLbEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _mergeLabels?;
    get mergeLabels(): boolean | cdktf.IResolvable;
    set mergeLabels(value: boolean | cdktf.IResolvable);
    resetMergeLabels(): void;
    get mergeLabelsInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get nodeAddresses(): string[];
    private _nodeCount?;
    get nodeCount(): number;
    set nodeCount(value: number);
    resetNodeCount(): void;
    get nodeCountInput(): number | undefined;
    get projectId(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get stackId(): string;
    get updatedAt(): string;
    get userId(): string;
    private _timeouts;
    get timeouts(): ContainerinfraClusterV1TimeoutsOutputReference;
    putTimeouts(value: ContainerinfraClusterV1Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | ContainerinfraClusterV1Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
