import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ContainerinfraClustertemplateV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#apiserver_port ContainerinfraClustertemplateV1#apiserver_port}
    */
    readonly apiserverPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#cluster_distro ContainerinfraClustertemplateV1#cluster_distro}
    */
    readonly clusterDistro?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#coe ContainerinfraClustertemplateV1#coe}
    */
    readonly coe: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#dns_nameserver ContainerinfraClustertemplateV1#dns_nameserver}
    */
    readonly dnsNameserver?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#docker_storage_driver ContainerinfraClustertemplateV1#docker_storage_driver}
    */
    readonly dockerStorageDriver?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#docker_volume_size ContainerinfraClustertemplateV1#docker_volume_size}
    */
    readonly dockerVolumeSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#external_network_id ContainerinfraClustertemplateV1#external_network_id}
    */
    readonly externalNetworkId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#fixed_network ContainerinfraClustertemplateV1#fixed_network}
    */
    readonly fixedNetwork?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#fixed_subnet ContainerinfraClustertemplateV1#fixed_subnet}
    */
    readonly fixedSubnet?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#flavor ContainerinfraClustertemplateV1#flavor}
    */
    readonly flavor?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#floating_ip_enabled ContainerinfraClustertemplateV1#floating_ip_enabled}
    */
    readonly floatingIpEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#hidden ContainerinfraClustertemplateV1#hidden}
    */
    readonly hidden?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#http_proxy ContainerinfraClustertemplateV1#http_proxy}
    */
    readonly httpProxy?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#https_proxy ContainerinfraClustertemplateV1#https_proxy}
    */
    readonly httpsProxy?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#id ContainerinfraClustertemplateV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#image ContainerinfraClustertemplateV1#image}
    */
    readonly image: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#insecure_registry ContainerinfraClustertemplateV1#insecure_registry}
    */
    readonly insecureRegistry?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#keypair_id ContainerinfraClustertemplateV1#keypair_id}
    */
    readonly keypairId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#labels ContainerinfraClustertemplateV1#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#master_flavor ContainerinfraClustertemplateV1#master_flavor}
    */
    readonly masterFlavor?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#master_lb_enabled ContainerinfraClustertemplateV1#master_lb_enabled}
    */
    readonly masterLbEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#name ContainerinfraClustertemplateV1#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#network_driver ContainerinfraClustertemplateV1#network_driver}
    */
    readonly networkDriver?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#no_proxy ContainerinfraClustertemplateV1#no_proxy}
    */
    readonly noProxy?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#public ContainerinfraClustertemplateV1#public}
    */
    readonly public?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#region ContainerinfraClustertemplateV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#registry_enabled ContainerinfraClustertemplateV1#registry_enabled}
    */
    readonly registryEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#server_type ContainerinfraClustertemplateV1#server_type}
    */
    readonly serverType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#tls_disabled ContainerinfraClustertemplateV1#tls_disabled}
    */
    readonly tlsDisabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#volume_driver ContainerinfraClustertemplateV1#volume_driver}
    */
    readonly volumeDriver?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#timeouts ContainerinfraClustertemplateV1#timeouts}
    */
    readonly timeouts?: ContainerinfraClustertemplateV1Timeouts;
}
export interface ContainerinfraClustertemplateV1Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#create ContainerinfraClustertemplateV1#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#delete ContainerinfraClustertemplateV1#delete}
    */
    readonly delete?: string;
}
export declare function containerinfraClustertemplateV1TimeoutsToTerraform(struct?: ContainerinfraClustertemplateV1Timeouts | cdktf.IResolvable): any;
export declare function containerinfraClustertemplateV1TimeoutsToHclTerraform(struct?: ContainerinfraClustertemplateV1Timeouts | cdktf.IResolvable): any;
export declare class ContainerinfraClustertemplateV1TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ContainerinfraClustertemplateV1Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: ContainerinfraClustertemplateV1Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1 openstack_containerinfra_clustertemplate_v1}
*/
export declare class ContainerinfraClustertemplateV1 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_containerinfra_clustertemplate_v1";
    /**
    * Generates CDKTF code for importing a ContainerinfraClustertemplateV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ContainerinfraClustertemplateV1 to import
    * @param importFromId The id of the existing ContainerinfraClustertemplateV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ContainerinfraClustertemplateV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/containerinfra_clustertemplate_v1 openstack_containerinfra_clustertemplate_v1} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ContainerinfraClustertemplateV1Config
    */
    constructor(scope: Construct, id: string, config: ContainerinfraClustertemplateV1Config);
    private _apiserverPort?;
    get apiserverPort(): number;
    set apiserverPort(value: number);
    resetApiserverPort(): void;
    get apiserverPortInput(): number | undefined;
    private _clusterDistro?;
    get clusterDistro(): string;
    set clusterDistro(value: string);
    resetClusterDistro(): void;
    get clusterDistroInput(): string | undefined;
    private _coe?;
    get coe(): string;
    set coe(value: string);
    get coeInput(): string | undefined;
    get createdAt(): string;
    private _dnsNameserver?;
    get dnsNameserver(): string;
    set dnsNameserver(value: string);
    resetDnsNameserver(): void;
    get dnsNameserverInput(): string | undefined;
    private _dockerStorageDriver?;
    get dockerStorageDriver(): string;
    set dockerStorageDriver(value: string);
    resetDockerStorageDriver(): void;
    get dockerStorageDriverInput(): string | undefined;
    private _dockerVolumeSize?;
    get dockerVolumeSize(): number;
    set dockerVolumeSize(value: number);
    resetDockerVolumeSize(): void;
    get dockerVolumeSizeInput(): number | undefined;
    private _externalNetworkId?;
    get externalNetworkId(): string;
    set externalNetworkId(value: string);
    resetExternalNetworkId(): void;
    get externalNetworkIdInput(): string | undefined;
    private _fixedNetwork?;
    get fixedNetwork(): string;
    set fixedNetwork(value: string);
    resetFixedNetwork(): void;
    get fixedNetworkInput(): string | undefined;
    private _fixedSubnet?;
    get fixedSubnet(): string;
    set fixedSubnet(value: string);
    resetFixedSubnet(): void;
    get fixedSubnetInput(): string | undefined;
    private _flavor?;
    get flavor(): string;
    set flavor(value: string);
    resetFlavor(): void;
    get flavorInput(): string | undefined;
    private _floatingIpEnabled?;
    get floatingIpEnabled(): boolean | cdktf.IResolvable;
    set floatingIpEnabled(value: boolean | cdktf.IResolvable);
    resetFloatingIpEnabled(): void;
    get floatingIpEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hidden?;
    get hidden(): boolean | cdktf.IResolvable;
    set hidden(value: boolean | cdktf.IResolvable);
    resetHidden(): void;
    get hiddenInput(): boolean | cdktf.IResolvable | undefined;
    private _httpProxy?;
    get httpProxy(): string;
    set httpProxy(value: string);
    resetHttpProxy(): void;
    get httpProxyInput(): string | undefined;
    private _httpsProxy?;
    get httpsProxy(): string;
    set httpsProxy(value: string);
    resetHttpsProxy(): void;
    get httpsProxyInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _image?;
    get image(): string;
    set image(value: string);
    get imageInput(): string | undefined;
    private _insecureRegistry?;
    get insecureRegistry(): string;
    set insecureRegistry(value: string);
    resetInsecureRegistry(): void;
    get insecureRegistryInput(): string | undefined;
    private _keypairId?;
    get keypairId(): string;
    set keypairId(value: string);
    resetKeypairId(): void;
    get keypairIdInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _masterFlavor?;
    get masterFlavor(): string;
    set masterFlavor(value: string);
    resetMasterFlavor(): void;
    get masterFlavorInput(): string | undefined;
    private _masterLbEnabled?;
    get masterLbEnabled(): boolean | cdktf.IResolvable;
    set masterLbEnabled(value: boolean | cdktf.IResolvable);
    resetMasterLbEnabled(): void;
    get masterLbEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networkDriver?;
    get networkDriver(): string;
    set networkDriver(value: string);
    resetNetworkDriver(): void;
    get networkDriverInput(): string | undefined;
    private _noProxy?;
    get noProxy(): string;
    set noProxy(value: string);
    resetNoProxy(): void;
    get noProxyInput(): string | undefined;
    get projectId(): string;
    private _public?;
    get public(): boolean | cdktf.IResolvable;
    set public(value: boolean | cdktf.IResolvable);
    resetPublic(): void;
    get publicInput(): boolean | cdktf.IResolvable | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _registryEnabled?;
    get registryEnabled(): boolean | cdktf.IResolvable;
    set registryEnabled(value: boolean | cdktf.IResolvable);
    resetRegistryEnabled(): void;
    get registryEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _serverType?;
    get serverType(): string;
    set serverType(value: string);
    resetServerType(): void;
    get serverTypeInput(): string | undefined;
    private _tlsDisabled?;
    get tlsDisabled(): boolean | cdktf.IResolvable;
    set tlsDisabled(value: boolean | cdktf.IResolvable);
    resetTlsDisabled(): void;
    get tlsDisabledInput(): boolean | cdktf.IResolvable | undefined;
    get updatedAt(): string;
    get userId(): string;
    private _volumeDriver?;
    get volumeDriver(): string;
    set volumeDriver(value: string);
    resetVolumeDriver(): void;
    get volumeDriverInput(): string | undefined;
    private _timeouts;
    get timeouts(): ContainerinfraClustertemplateV1TimeoutsOutputReference;
    putTimeouts(value: ContainerinfraClustertemplateV1Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | ContainerinfraClustertemplateV1Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
