import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackBlockstorageAvailabilityZonesV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_availability_zones_v3#id DataOpenstackBlockstorageAvailabilityZonesV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_availability_zones_v3#region DataOpenstackBlockstorageAvailabilityZonesV3#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_availability_zones_v3#state DataOpenstackBlockstorageAvailabilityZonesV3#state}
    */
    readonly state?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_availability_zones_v3 openstack_blockstorage_availability_zones_v3}
*/
export declare class DataOpenstackBlockstorageAvailabilityZonesV3 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_blockstorage_availability_zones_v3";
    /**
    * Generates CDKTF code for importing a DataOpenstackBlockstorageAvailabilityZonesV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackBlockstorageAvailabilityZonesV3 to import
    * @param importFromId The id of the existing DataOpenstackBlockstorageAvailabilityZonesV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_availability_zones_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackBlockstorageAvailabilityZonesV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_availability_zones_v3 openstack_blockstorage_availability_zones_v3} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackBlockstorageAvailabilityZonesV3Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackBlockstorageAvailabilityZonesV3Config);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get names(): string[];
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _state?;
    get state(): string;
    set state(value: string);
    resetState(): void;
    get stateInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
