import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackBlockstorageQuotasetV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_quotaset_v3#id DataOpenstackBlockstorageQuotasetV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_quotaset_v3#project_id DataOpenstackBlockstorageQuotasetV3#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_quotaset_v3#region DataOpenstackBlockstorageQuotasetV3#region}
    */
    readonly region?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_quotaset_v3 openstack_blockstorage_quotaset_v3}
*/
export declare class DataOpenstackBlockstorageQuotasetV3 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_blockstorage_quotaset_v3";
    /**
    * Generates CDKTF code for importing a DataOpenstackBlockstorageQuotasetV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackBlockstorageQuotasetV3 to import
    * @param importFromId The id of the existing DataOpenstackBlockstorageQuotasetV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_quotaset_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackBlockstorageQuotasetV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_quotaset_v3 openstack_blockstorage_quotaset_v3} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackBlockstorageQuotasetV3Config
    */
    constructor(scope: Construct, id: string, config: DataOpenstackBlockstorageQuotasetV3Config);
    get backupGigabytes(): number;
    get backups(): number;
    get gigabytes(): number;
    get groups(): number;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get perVolumeGigabytes(): number;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get snapshots(): number;
    private _volumeTypeQuota;
    get volumeTypeQuota(): cdktf.StringMap;
    get volumes(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
