import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackBlockstorageVolumeV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3#bootable DataOpenstackBlockstorageVolumeV3#bootable}
    */
    readonly bootable?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3#host DataOpenstackBlockstorageVolumeV3#host}
    */
    readonly host?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3#id DataOpenstackBlockstorageVolumeV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3#metadata DataOpenstackBlockstorageVolumeV3#metadata}
    */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3#name DataOpenstackBlockstorageVolumeV3#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3#region DataOpenstackBlockstorageVolumeV3#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3#status DataOpenstackBlockstorageVolumeV3#status}
    */
    readonly status?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3#volume_type DataOpenstackBlockstorageVolumeV3#volume_type}
    */
    readonly volumeType?: string;
}
export interface DataOpenstackBlockstorageVolumeV3Attachment {
}
export declare function dataOpenstackBlockstorageVolumeV3AttachmentToTerraform(struct?: DataOpenstackBlockstorageVolumeV3Attachment): any;
export declare function dataOpenstackBlockstorageVolumeV3AttachmentToHclTerraform(struct?: DataOpenstackBlockstorageVolumeV3Attachment): any;
export declare class DataOpenstackBlockstorageVolumeV3AttachmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackBlockstorageVolumeV3Attachment | undefined;
    set internalValue(value: DataOpenstackBlockstorageVolumeV3Attachment | undefined);
    get device(): string;
    get id(): string;
    get instanceId(): string;
}
export declare class DataOpenstackBlockstorageVolumeV3AttachmentList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackBlockstorageVolumeV3AttachmentOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3 openstack_blockstorage_volume_v3}
*/
export declare class DataOpenstackBlockstorageVolumeV3 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_blockstorage_volume_v3";
    /**
    * Generates CDKTF code for importing a DataOpenstackBlockstorageVolumeV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackBlockstorageVolumeV3 to import
    * @param importFromId The id of the existing DataOpenstackBlockstorageVolumeV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackBlockstorageVolumeV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/blockstorage_volume_v3 openstack_blockstorage_volume_v3} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackBlockstorageVolumeV3Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackBlockstorageVolumeV3Config);
    private _attachment;
    get attachment(): DataOpenstackBlockstorageVolumeV3AttachmentList;
    private _bootable?;
    get bootable(): string;
    set bootable(value: string);
    resetBootable(): void;
    get bootableInput(): string | undefined;
    private _host?;
    get host(): string;
    set host(value: string);
    resetHost(): void;
    get hostInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _metadata?;
    get metadata(): {
        [key: string]: string;
    };
    set metadata(value: {
        [key: string]: string;
    });
    resetMetadata(): void;
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get size(): number;
    get sourceVolumeId(): string;
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
    private _volumeType?;
    get volumeType(): string;
    set volumeType(value: string);
    resetVolumeType(): void;
    get volumeTypeInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
