import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackComputeHypervisorV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_hypervisor_v2#hostname DataOpenstackComputeHypervisorV2#hostname}
    */
    readonly hostname: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_hypervisor_v2#id DataOpenstackComputeHypervisorV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_hypervisor_v2 openstack_compute_hypervisor_v2}
*/
export declare class DataOpenstackComputeHypervisorV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_compute_hypervisor_v2";
    /**
    * Generates CDKTF code for importing a DataOpenstackComputeHypervisorV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackComputeHypervisorV2 to import
    * @param importFromId The id of the existing DataOpenstackComputeHypervisorV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_hypervisor_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackComputeHypervisorV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_hypervisor_v2 openstack_compute_hypervisor_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackComputeHypervisorV2Config
    */
    constructor(scope: Construct, id: string, config: DataOpenstackComputeHypervisorV2Config);
    get disk(): number;
    get hostIp(): string;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    get hostnameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get memory(): number;
    get state(): string;
    get status(): string;
    get type(): string;
    get vcpus(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
