import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackComputeInstanceV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_instance_v2#id DataOpenstackComputeInstanceV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_instance_v2#region DataOpenstackComputeInstanceV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_instance_v2#user_data DataOpenstackComputeInstanceV2#user_data}
    */
    readonly userData?: string;
    /**
    * network block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_instance_v2#network DataOpenstackComputeInstanceV2#network}
    */
    readonly network?: DataOpenstackComputeInstanceV2Network[] | cdktf.IResolvable;
}
export interface DataOpenstackComputeInstanceV2Network {
}
export declare function dataOpenstackComputeInstanceV2NetworkToTerraform(struct?: DataOpenstackComputeInstanceV2Network | cdktf.IResolvable): any;
export declare function dataOpenstackComputeInstanceV2NetworkToHclTerraform(struct?: DataOpenstackComputeInstanceV2Network | cdktf.IResolvable): any;
export declare class DataOpenstackComputeInstanceV2NetworkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackComputeInstanceV2Network | cdktf.IResolvable | undefined;
    set internalValue(value: DataOpenstackComputeInstanceV2Network | cdktf.IResolvable | undefined);
    get fixedIpV4(): string;
    get fixedIpV6(): string;
    get mac(): string;
    get name(): string;
    get port(): string;
    get uuid(): string;
}
export declare class DataOpenstackComputeInstanceV2NetworkList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataOpenstackComputeInstanceV2Network[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackComputeInstanceV2NetworkOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_instance_v2 openstack_compute_instance_v2}
*/
export declare class DataOpenstackComputeInstanceV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_compute_instance_v2";
    /**
    * Generates CDKTF code for importing a DataOpenstackComputeInstanceV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackComputeInstanceV2 to import
    * @param importFromId The id of the existing DataOpenstackComputeInstanceV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_instance_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackComputeInstanceV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/compute_instance_v2 openstack_compute_instance_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackComputeInstanceV2Config
    */
    constructor(scope: Construct, id: string, config: DataOpenstackComputeInstanceV2Config);
    get accessIpV4(): string;
    get accessIpV6(): string;
    get availabilityZone(): string;
    get created(): string;
    get flavorId(): string;
    get flavorName(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
    get imageId(): string;
    get imageName(): string;
    get keyPair(): string;
    private _metadata;
    get metadata(): cdktf.StringMap;
    get name(): string;
    get powerState(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get securityGroups(): string[];
    get tags(): string[];
    get updated(): string;
    private _userData?;
    get userData(): string;
    set userData(value: string);
    resetUserData(): void;
    get userDataInput(): string | undefined;
    private _network;
    get network(): DataOpenstackComputeInstanceV2NetworkList;
    putNetwork(value: DataOpenstackComputeInstanceV2Network[] | cdktf.IResolvable): void;
    resetNetwork(): void;
    get networkInput(): cdktf.IResolvable | DataOpenstackComputeInstanceV2Network[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
