import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackContainerinfraClusterV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_cluster_v1#id DataOpenstackContainerinfraClusterV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_cluster_v1#name DataOpenstackContainerinfraClusterV1#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_cluster_v1#region DataOpenstackContainerinfraClusterV1#region}
    */
    readonly region?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_cluster_v1 openstack_containerinfra_cluster_v1}
*/
export declare class DataOpenstackContainerinfraClusterV1 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_containerinfra_cluster_v1";
    /**
    * Generates CDKTF code for importing a DataOpenstackContainerinfraClusterV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackContainerinfraClusterV1 to import
    * @param importFromId The id of the existing DataOpenstackContainerinfraClusterV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_cluster_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackContainerinfraClusterV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_cluster_v1 openstack_containerinfra_cluster_v1} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackContainerinfraClusterV1Config
    */
    constructor(scope: Construct, id: string, config: DataOpenstackContainerinfraClusterV1Config);
    get apiAddress(): string;
    get clusterTemplateId(): string;
    get coeVersion(): string;
    get containerVersion(): string;
    get createTimeout(): number;
    get createdAt(): string;
    get discoveryUrl(): string;
    get dockerVolumeSize(): number;
    get fixedNetwork(): string;
    get fixedSubnet(): string;
    get flavor(): string;
    get floatingIpEnabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get keypair(): string;
    private _kubeconfig;
    get kubeconfig(): cdktf.StringMap;
    private _labels;
    get labels(): cdktf.StringMap;
    get masterAddresses(): string[];
    get masterCount(): number;
    get masterFlavor(): string;
    get masterLbEnabled(): cdktf.IResolvable;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get nodeAddresses(): string[];
    get nodeCount(): number;
    get projectId(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get stackId(): string;
    get updatedAt(): string;
    get userId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
