import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackContainerinfraClustertemplateV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_clustertemplate_v1#id DataOpenstackContainerinfraClustertemplateV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_clustertemplate_v1#name DataOpenstackContainerinfraClustertemplateV1#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_clustertemplate_v1#region DataOpenstackContainerinfraClustertemplateV1#region}
    */
    readonly region?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_clustertemplate_v1 openstack_containerinfra_clustertemplate_v1}
*/
export declare class DataOpenstackContainerinfraClustertemplateV1 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_containerinfra_clustertemplate_v1";
    /**
    * Generates CDKTF code for importing a DataOpenstackContainerinfraClustertemplateV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackContainerinfraClustertemplateV1 to import
    * @param importFromId The id of the existing DataOpenstackContainerinfraClustertemplateV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_clustertemplate_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackContainerinfraClustertemplateV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/containerinfra_clustertemplate_v1 openstack_containerinfra_clustertemplate_v1} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackContainerinfraClustertemplateV1Config
    */
    constructor(scope: Construct, id: string, config: DataOpenstackContainerinfraClustertemplateV1Config);
    get apiserverPort(): number;
    get clusterDistro(): string;
    get coe(): string;
    get createdAt(): string;
    get dnsNameserver(): string;
    get dockerStorageDriver(): string;
    get dockerVolumeSize(): number;
    get externalNetworkId(): string;
    get fixedNetwork(): string;
    get fixedSubnet(): string;
    get flavor(): string;
    get floatingIpEnabled(): cdktf.IResolvable;
    get hidden(): cdktf.IResolvable;
    get httpProxy(): string;
    get httpsProxy(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get image(): string;
    get insecureRegistry(): string;
    get keypairId(): string;
    private _labels;
    get labels(): cdktf.StringMap;
    get masterFlavor(): string;
    get masterLbEnabled(): cdktf.IResolvable;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get networkDriver(): string;
    get noProxy(): string;
    get projectId(): string;
    get public(): cdktf.IResolvable;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get registryEnabled(): cdktf.IResolvable;
    get serverType(): string;
    get tlsDisabled(): cdktf.IResolvable;
    get updatedAt(): string;
    get userId(): string;
    get volumeDriver(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
