import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackIdentityAuthScopeV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_auth_scope_v3#id DataOpenstackIdentityAuthScopeV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_auth_scope_v3#name DataOpenstackIdentityAuthScopeV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_auth_scope_v3#region DataOpenstackIdentityAuthScopeV3#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_auth_scope_v3#set_token_id DataOpenstackIdentityAuthScopeV3#set_token_id}
    */
    readonly setTokenId?: boolean | cdktf.IResolvable;
}
export interface DataOpenstackIdentityAuthScopeV3Roles {
}
export declare function dataOpenstackIdentityAuthScopeV3RolesToTerraform(struct?: DataOpenstackIdentityAuthScopeV3Roles): any;
export declare function dataOpenstackIdentityAuthScopeV3RolesToHclTerraform(struct?: DataOpenstackIdentityAuthScopeV3Roles): any;
export declare class DataOpenstackIdentityAuthScopeV3RolesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackIdentityAuthScopeV3Roles | undefined;
    set internalValue(value: DataOpenstackIdentityAuthScopeV3Roles | undefined);
    get roleId(): string;
    get roleName(): string;
}
export declare class DataOpenstackIdentityAuthScopeV3RolesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackIdentityAuthScopeV3RolesOutputReference;
}
export interface DataOpenstackIdentityAuthScopeV3ServiceCatalogEndpoints {
}
export declare function dataOpenstackIdentityAuthScopeV3ServiceCatalogEndpointsToTerraform(struct?: DataOpenstackIdentityAuthScopeV3ServiceCatalogEndpoints): any;
export declare function dataOpenstackIdentityAuthScopeV3ServiceCatalogEndpointsToHclTerraform(struct?: DataOpenstackIdentityAuthScopeV3ServiceCatalogEndpoints): any;
export declare class DataOpenstackIdentityAuthScopeV3ServiceCatalogEndpointsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackIdentityAuthScopeV3ServiceCatalogEndpoints | undefined;
    set internalValue(value: DataOpenstackIdentityAuthScopeV3ServiceCatalogEndpoints | undefined);
    get id(): string;
    get interface(): string;
    get region(): string;
    get regionId(): string;
    get url(): string;
}
export declare class DataOpenstackIdentityAuthScopeV3ServiceCatalogEndpointsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackIdentityAuthScopeV3ServiceCatalogEndpointsOutputReference;
}
export interface DataOpenstackIdentityAuthScopeV3ServiceCatalog {
}
export declare function dataOpenstackIdentityAuthScopeV3ServiceCatalogToTerraform(struct?: DataOpenstackIdentityAuthScopeV3ServiceCatalog): any;
export declare function dataOpenstackIdentityAuthScopeV3ServiceCatalogToHclTerraform(struct?: DataOpenstackIdentityAuthScopeV3ServiceCatalog): any;
export declare class DataOpenstackIdentityAuthScopeV3ServiceCatalogOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackIdentityAuthScopeV3ServiceCatalog | undefined;
    set internalValue(value: DataOpenstackIdentityAuthScopeV3ServiceCatalog | undefined);
    private _endpoints;
    get endpoints(): DataOpenstackIdentityAuthScopeV3ServiceCatalogEndpointsList;
    get id(): string;
    get name(): string;
    get type(): string;
}
export declare class DataOpenstackIdentityAuthScopeV3ServiceCatalogList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackIdentityAuthScopeV3ServiceCatalogOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_auth_scope_v3 openstack_identity_auth_scope_v3}
*/
export declare class DataOpenstackIdentityAuthScopeV3 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_identity_auth_scope_v3";
    /**
    * Generates CDKTF code for importing a DataOpenstackIdentityAuthScopeV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackIdentityAuthScopeV3 to import
    * @param importFromId The id of the existing DataOpenstackIdentityAuthScopeV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_auth_scope_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackIdentityAuthScopeV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_auth_scope_v3 openstack_identity_auth_scope_v3} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackIdentityAuthScopeV3Config
    */
    constructor(scope: Construct, id: string, config: DataOpenstackIdentityAuthScopeV3Config);
    get domainId(): string;
    get domainName(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get projectDomainId(): string;
    get projectDomainName(): string;
    get projectId(): string;
    get projectName(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _roles;
    get roles(): DataOpenstackIdentityAuthScopeV3RolesList;
    private _serviceCatalog;
    get serviceCatalog(): DataOpenstackIdentityAuthScopeV3ServiceCatalogList;
    private _setTokenId?;
    get setTokenId(): boolean | cdktf.IResolvable;
    set setTokenId(value: boolean | cdktf.IResolvable);
    resetSetTokenId(): void;
    get setTokenIdInput(): boolean | cdktf.IResolvable | undefined;
    get tokenId(): string;
    get userDomainId(): string;
    get userDomainName(): string;
    get userId(): string;
    get userName(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
