import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackIdentityUserV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3#domain_id DataOpenstackIdentityUserV3#domain_id}
    */
    readonly domainId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3#enabled DataOpenstackIdentityUserV3#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3#id DataOpenstackIdentityUserV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3#idp_id DataOpenstackIdentityUserV3#idp_id}
    */
    readonly idpId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3#name DataOpenstackIdentityUserV3#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3#password_expires_at DataOpenstackIdentityUserV3#password_expires_at}
    */
    readonly passwordExpiresAt?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3#protocol_id DataOpenstackIdentityUserV3#protocol_id}
    */
    readonly protocolId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3#region DataOpenstackIdentityUserV3#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3#unique_id DataOpenstackIdentityUserV3#unique_id}
    */
    readonly uniqueId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3 openstack_identity_user_v3}
*/
export declare class DataOpenstackIdentityUserV3 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_identity_user_v3";
    /**
    * Generates CDKTF code for importing a DataOpenstackIdentityUserV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackIdentityUserV3 to import
    * @param importFromId The id of the existing DataOpenstackIdentityUserV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackIdentityUserV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/identity_user_v3 openstack_identity_user_v3} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackIdentityUserV3Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackIdentityUserV3Config);
    get defaultProjectId(): string;
    get description(): string;
    private _domainId?;
    get domainId(): string;
    set domainId(value: string);
    resetDomainId(): void;
    get domainIdInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _idpId?;
    get idpId(): string;
    set idpId(value: string);
    resetIdpId(): void;
    get idpIdInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _passwordExpiresAt?;
    get passwordExpiresAt(): string;
    set passwordExpiresAt(value: string);
    resetPasswordExpiresAt(): void;
    get passwordExpiresAtInput(): string | undefined;
    private _protocolId?;
    get protocolId(): string;
    set protocolId(value: string);
    resetProtocolId(): void;
    get protocolIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _uniqueId?;
    get uniqueId(): string;
    set uniqueId(value: string);
    resetUniqueId(): void;
    get uniqueIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
