import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackKeymanagerContainerV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_container_v1#id DataOpenstackKeymanagerContainerV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_container_v1#name DataOpenstackKeymanagerContainerV1#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_container_v1#region DataOpenstackKeymanagerContainerV1#region}
    */
    readonly region?: string;
}
export interface DataOpenstackKeymanagerContainerV1AclRead {
}
export declare function dataOpenstackKeymanagerContainerV1AclReadToTerraform(struct?: DataOpenstackKeymanagerContainerV1AclRead): any;
export declare function dataOpenstackKeymanagerContainerV1AclReadToHclTerraform(struct?: DataOpenstackKeymanagerContainerV1AclRead): any;
export declare class DataOpenstackKeymanagerContainerV1AclReadOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackKeymanagerContainerV1AclRead | undefined;
    set internalValue(value: DataOpenstackKeymanagerContainerV1AclRead | undefined);
    get createdAt(): string;
    get projectAccess(): cdktf.IResolvable;
    get updatedAt(): string;
    get users(): string[];
}
export declare class DataOpenstackKeymanagerContainerV1AclReadList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackKeymanagerContainerV1AclReadOutputReference;
}
export interface DataOpenstackKeymanagerContainerV1Acl {
}
export declare function dataOpenstackKeymanagerContainerV1AclToTerraform(struct?: DataOpenstackKeymanagerContainerV1Acl): any;
export declare function dataOpenstackKeymanagerContainerV1AclToHclTerraform(struct?: DataOpenstackKeymanagerContainerV1Acl): any;
export declare class DataOpenstackKeymanagerContainerV1AclOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackKeymanagerContainerV1Acl | undefined;
    set internalValue(value: DataOpenstackKeymanagerContainerV1Acl | undefined);
    private _read;
    get read(): DataOpenstackKeymanagerContainerV1AclReadList;
}
export declare class DataOpenstackKeymanagerContainerV1AclList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackKeymanagerContainerV1AclOutputReference;
}
export interface DataOpenstackKeymanagerContainerV1Consumers {
}
export declare function dataOpenstackKeymanagerContainerV1ConsumersToTerraform(struct?: DataOpenstackKeymanagerContainerV1Consumers): any;
export declare function dataOpenstackKeymanagerContainerV1ConsumersToHclTerraform(struct?: DataOpenstackKeymanagerContainerV1Consumers): any;
export declare class DataOpenstackKeymanagerContainerV1ConsumersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackKeymanagerContainerV1Consumers | undefined;
    set internalValue(value: DataOpenstackKeymanagerContainerV1Consumers | undefined);
    get name(): string;
    get url(): string;
}
export declare class DataOpenstackKeymanagerContainerV1ConsumersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackKeymanagerContainerV1ConsumersOutputReference;
}
export interface DataOpenstackKeymanagerContainerV1SecretRefs {
}
export declare function dataOpenstackKeymanagerContainerV1SecretRefsToTerraform(struct?: DataOpenstackKeymanagerContainerV1SecretRefs): any;
export declare function dataOpenstackKeymanagerContainerV1SecretRefsToHclTerraform(struct?: DataOpenstackKeymanagerContainerV1SecretRefs): any;
export declare class DataOpenstackKeymanagerContainerV1SecretRefsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackKeymanagerContainerV1SecretRefs | undefined;
    set internalValue(value: DataOpenstackKeymanagerContainerV1SecretRefs | undefined);
    get name(): string;
    get secretRef(): string;
}
export declare class DataOpenstackKeymanagerContainerV1SecretRefsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackKeymanagerContainerV1SecretRefsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_container_v1 openstack_keymanager_container_v1}
*/
export declare class DataOpenstackKeymanagerContainerV1 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_keymanager_container_v1";
    /**
    * Generates CDKTF code for importing a DataOpenstackKeymanagerContainerV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackKeymanagerContainerV1 to import
    * @param importFromId The id of the existing DataOpenstackKeymanagerContainerV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_container_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackKeymanagerContainerV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_container_v1 openstack_keymanager_container_v1} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackKeymanagerContainerV1Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackKeymanagerContainerV1Config);
    private _acl;
    get acl(): DataOpenstackKeymanagerContainerV1AclList;
    private _consumers;
    get consumers(): DataOpenstackKeymanagerContainerV1ConsumersList;
    get containerRef(): string;
    get createdAt(): string;
    get creatorId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _secretRefs;
    get secretRefs(): DataOpenstackKeymanagerContainerV1SecretRefsList;
    get status(): string;
    get type(): string;
    get updatedAt(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
