import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackKeymanagerSecretV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#acl_only DataOpenstackKeymanagerSecretV1#acl_only}
    */
    readonly aclOnly?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#algorithm DataOpenstackKeymanagerSecretV1#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#bit_length DataOpenstackKeymanagerSecretV1#bit_length}
    */
    readonly bitLength?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#created_at_filter DataOpenstackKeymanagerSecretV1#created_at_filter}
    */
    readonly createdAtFilter?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#expiration_filter DataOpenstackKeymanagerSecretV1#expiration_filter}
    */
    readonly expirationFilter?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#id DataOpenstackKeymanagerSecretV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#mode DataOpenstackKeymanagerSecretV1#mode}
    */
    readonly mode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#name DataOpenstackKeymanagerSecretV1#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#region DataOpenstackKeymanagerSecretV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#secret_type DataOpenstackKeymanagerSecretV1#secret_type}
    */
    readonly secretType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#updated_at_filter DataOpenstackKeymanagerSecretV1#updated_at_filter}
    */
    readonly updatedAtFilter?: string;
}
export interface DataOpenstackKeymanagerSecretV1AclRead {
}
export declare function dataOpenstackKeymanagerSecretV1AclReadToTerraform(struct?: DataOpenstackKeymanagerSecretV1AclRead): any;
export declare function dataOpenstackKeymanagerSecretV1AclReadToHclTerraform(struct?: DataOpenstackKeymanagerSecretV1AclRead): any;
export declare class DataOpenstackKeymanagerSecretV1AclReadOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackKeymanagerSecretV1AclRead | undefined;
    set internalValue(value: DataOpenstackKeymanagerSecretV1AclRead | undefined);
    get createdAt(): string;
    get projectAccess(): cdktf.IResolvable;
    get updatedAt(): string;
    get users(): string[];
}
export declare class DataOpenstackKeymanagerSecretV1AclReadList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackKeymanagerSecretV1AclReadOutputReference;
}
export interface DataOpenstackKeymanagerSecretV1Acl {
}
export declare function dataOpenstackKeymanagerSecretV1AclToTerraform(struct?: DataOpenstackKeymanagerSecretV1Acl): any;
export declare function dataOpenstackKeymanagerSecretV1AclToHclTerraform(struct?: DataOpenstackKeymanagerSecretV1Acl): any;
export declare class DataOpenstackKeymanagerSecretV1AclOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackKeymanagerSecretV1Acl | undefined;
    set internalValue(value: DataOpenstackKeymanagerSecretV1Acl | undefined);
    private _read;
    get read(): DataOpenstackKeymanagerSecretV1AclReadList;
}
export declare class DataOpenstackKeymanagerSecretV1AclList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackKeymanagerSecretV1AclOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1 openstack_keymanager_secret_v1}
*/
export declare class DataOpenstackKeymanagerSecretV1 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_keymanager_secret_v1";
    /**
    * Generates CDKTF code for importing a DataOpenstackKeymanagerSecretV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackKeymanagerSecretV1 to import
    * @param importFromId The id of the existing DataOpenstackKeymanagerSecretV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackKeymanagerSecretV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/keymanager_secret_v1 openstack_keymanager_secret_v1} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackKeymanagerSecretV1Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackKeymanagerSecretV1Config);
    private _acl;
    get acl(): DataOpenstackKeymanagerSecretV1AclList;
    private _aclOnly?;
    get aclOnly(): boolean | cdktf.IResolvable;
    set aclOnly(value: boolean | cdktf.IResolvable);
    resetAclOnly(): void;
    get aclOnlyInput(): boolean | cdktf.IResolvable | undefined;
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _bitLength?;
    get bitLength(): number;
    set bitLength(value: number);
    resetBitLength(): void;
    get bitLengthInput(): number | undefined;
    private _contentTypes;
    get contentTypes(): cdktf.StringMap;
    get createdAt(): string;
    private _createdAtFilter?;
    get createdAtFilter(): string;
    set createdAtFilter(value: string);
    resetCreatedAtFilter(): void;
    get createdAtFilterInput(): string | undefined;
    get creatorId(): string;
    get expiration(): string;
    private _expirationFilter?;
    get expirationFilter(): string;
    set expirationFilter(value: string);
    resetExpirationFilter(): void;
    get expirationFilterInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _metadata;
    get metadata(): cdktf.StringMap;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    resetMode(): void;
    get modeInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get payload(): string;
    get payloadContentEncoding(): string;
    get payloadContentType(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get secretRef(): string;
    private _secretType?;
    get secretType(): string;
    set secretType(value: string);
    resetSecretType(): void;
    get secretTypeInput(): string | undefined;
    get status(): string;
    get updatedAt(): string;
    private _updatedAtFilter?;
    get updatedAtFilter(): string;
    set updatedAtFilter(value: string);
    resetUpdatedAtFilter(): void;
    get updatedAtFilterInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
