import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackNetworkingQosBandwidthLimitRuleV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_qos_bandwidth_limit_rule_v2#id DataOpenstackNetworkingQosBandwidthLimitRuleV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_qos_bandwidth_limit_rule_v2#max_burst_kbps DataOpenstackNetworkingQosBandwidthLimitRuleV2#max_burst_kbps}
    */
    readonly maxBurstKbps?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_qos_bandwidth_limit_rule_v2#max_kbps DataOpenstackNetworkingQosBandwidthLimitRuleV2#max_kbps}
    */
    readonly maxKbps?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_qos_bandwidth_limit_rule_v2#qos_policy_id DataOpenstackNetworkingQosBandwidthLimitRuleV2#qos_policy_id}
    */
    readonly qosPolicyId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_qos_bandwidth_limit_rule_v2#region DataOpenstackNetworkingQosBandwidthLimitRuleV2#region}
    */
    readonly region?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_qos_bandwidth_limit_rule_v2 openstack_networking_qos_bandwidth_limit_rule_v2}
*/
export declare class DataOpenstackNetworkingQosBandwidthLimitRuleV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_networking_qos_bandwidth_limit_rule_v2";
    /**
    * Generates CDKTF code for importing a DataOpenstackNetworkingQosBandwidthLimitRuleV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackNetworkingQosBandwidthLimitRuleV2 to import
    * @param importFromId The id of the existing DataOpenstackNetworkingQosBandwidthLimitRuleV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_qos_bandwidth_limit_rule_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackNetworkingQosBandwidthLimitRuleV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_qos_bandwidth_limit_rule_v2 openstack_networking_qos_bandwidth_limit_rule_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackNetworkingQosBandwidthLimitRuleV2Config
    */
    constructor(scope: Construct, id: string, config: DataOpenstackNetworkingQosBandwidthLimitRuleV2Config);
    get direction(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _maxBurstKbps?;
    get maxBurstKbps(): number;
    set maxBurstKbps(value: number);
    resetMaxBurstKbps(): void;
    get maxBurstKbpsInput(): number | undefined;
    private _maxKbps?;
    get maxKbps(): number;
    set maxKbps(value: number);
    resetMaxKbps(): void;
    get maxKbpsInput(): number | undefined;
    private _qosPolicyId?;
    get qosPolicyId(): string;
    set qosPolicyId(value: string);
    get qosPolicyIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
