import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackNetworkingQuotaV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_quota_v2#id DataOpenstackNetworkingQuotaV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_quota_v2#project_id DataOpenstackNetworkingQuotaV2#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_quota_v2#region DataOpenstackNetworkingQuotaV2#region}
    */
    readonly region?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_quota_v2 openstack_networking_quota_v2}
*/
export declare class DataOpenstackNetworkingQuotaV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_networking_quota_v2";
    /**
    * Generates CDKTF code for importing a DataOpenstackNetworkingQuotaV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackNetworkingQuotaV2 to import
    * @param importFromId The id of the existing DataOpenstackNetworkingQuotaV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_quota_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackNetworkingQuotaV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_quota_v2 openstack_networking_quota_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackNetworkingQuotaV2Config
    */
    constructor(scope: Construct, id: string, config: DataOpenstackNetworkingQuotaV2Config);
    get floatingip(): number;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get network(): number;
    get port(): number;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    get rbacPolicy(): number;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get router(): number;
    get securityGroup(): number;
    get securityGroupRule(): number;
    get subnet(): number;
    get subnetpool(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
