import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackNetworkingSecgroupV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2#description DataOpenstackNetworkingSecgroupV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2#id DataOpenstackNetworkingSecgroupV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2#name DataOpenstackNetworkingSecgroupV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2#region DataOpenstackNetworkingSecgroupV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2#secgroup_id DataOpenstackNetworkingSecgroupV2#secgroup_id}
    */
    readonly secgroupId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2#stateful DataOpenstackNetworkingSecgroupV2#stateful}
    */
    readonly stateful?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2#tags DataOpenstackNetworkingSecgroupV2#tags}
    */
    readonly tags?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2#tenant_id DataOpenstackNetworkingSecgroupV2#tenant_id}
    */
    readonly tenantId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2 openstack_networking_secgroup_v2}
*/
export declare class DataOpenstackNetworkingSecgroupV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_networking_secgroup_v2";
    /**
    * Generates CDKTF code for importing a DataOpenstackNetworkingSecgroupV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackNetworkingSecgroupV2 to import
    * @param importFromId The id of the existing DataOpenstackNetworkingSecgroupV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackNetworkingSecgroupV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_secgroup_v2 openstack_networking_secgroup_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackNetworkingSecgroupV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackNetworkingSecgroupV2Config);
    get allTags(): string[];
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _secgroupId?;
    get secgroupId(): string;
    set secgroupId(value: string);
    resetSecgroupId(): void;
    get secgroupIdInput(): string | undefined;
    private _stateful?;
    get stateful(): boolean | cdktf.IResolvable;
    set stateful(value: boolean | cdktf.IResolvable);
    resetStateful(): void;
    get statefulInput(): boolean | cdktf.IResolvable | undefined;
    private _tags?;
    get tags(): string[];
    set tags(value: string[]);
    resetTags(): void;
    get tagsInput(): string[] | undefined;
    private _tenantId?;
    get tenantId(): string;
    set tenantId(value: string);
    resetTenantId(): void;
    get tenantIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
