import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackNetworkingSubnetV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#cidr DataOpenstackNetworkingSubnetV2#cidr}
    */
    readonly cidr?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#description DataOpenstackNetworkingSubnetV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#dhcp_enabled DataOpenstackNetworkingSubnetV2#dhcp_enabled}
    */
    readonly dhcpEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#dns_publish_fixed_ip DataOpenstackNetworkingSubnetV2#dns_publish_fixed_ip}
    */
    readonly dnsPublishFixedIp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#gateway_ip DataOpenstackNetworkingSubnetV2#gateway_ip}
    */
    readonly gatewayIp?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#id DataOpenstackNetworkingSubnetV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#ip_version DataOpenstackNetworkingSubnetV2#ip_version}
    */
    readonly ipVersion?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#ipv6_address_mode DataOpenstackNetworkingSubnetV2#ipv6_address_mode}
    */
    readonly ipv6AddressMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#ipv6_ra_mode DataOpenstackNetworkingSubnetV2#ipv6_ra_mode}
    */
    readonly ipv6RaMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#name DataOpenstackNetworkingSubnetV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#network_id DataOpenstackNetworkingSubnetV2#network_id}
    */
    readonly networkId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#region DataOpenstackNetworkingSubnetV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#subnet_id DataOpenstackNetworkingSubnetV2#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#subnetpool_id DataOpenstackNetworkingSubnetV2#subnetpool_id}
    */
    readonly subnetpoolId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#tags DataOpenstackNetworkingSubnetV2#tags}
    */
    readonly tags?: string[];
    /**
    * The ID of the Tenant (Identity v2) or Project (Identity v3)
    * to login with.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#tenant_id DataOpenstackNetworkingSubnetV2#tenant_id}
    */
    readonly tenantId?: string;
}
export interface DataOpenstackNetworkingSubnetV2AllocationPools {
}
export declare function dataOpenstackNetworkingSubnetV2AllocationPoolsToTerraform(struct?: DataOpenstackNetworkingSubnetV2AllocationPools): any;
export declare function dataOpenstackNetworkingSubnetV2AllocationPoolsToHclTerraform(struct?: DataOpenstackNetworkingSubnetV2AllocationPools): any;
export declare class DataOpenstackNetworkingSubnetV2AllocationPoolsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackNetworkingSubnetV2AllocationPools | undefined;
    set internalValue(value: DataOpenstackNetworkingSubnetV2AllocationPools | undefined);
    get end(): string;
    get start(): string;
}
export declare class DataOpenstackNetworkingSubnetV2AllocationPoolsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackNetworkingSubnetV2AllocationPoolsOutputReference;
}
export interface DataOpenstackNetworkingSubnetV2HostRoutes {
}
export declare function dataOpenstackNetworkingSubnetV2HostRoutesToTerraform(struct?: DataOpenstackNetworkingSubnetV2HostRoutes): any;
export declare function dataOpenstackNetworkingSubnetV2HostRoutesToHclTerraform(struct?: DataOpenstackNetworkingSubnetV2HostRoutes): any;
export declare class DataOpenstackNetworkingSubnetV2HostRoutesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackNetworkingSubnetV2HostRoutes | undefined;
    set internalValue(value: DataOpenstackNetworkingSubnetV2HostRoutes | undefined);
    get destinationCidr(): string;
    get nextHop(): string;
}
export declare class DataOpenstackNetworkingSubnetV2HostRoutesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackNetworkingSubnetV2HostRoutesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2 openstack_networking_subnet_v2}
*/
export declare class DataOpenstackNetworkingSubnetV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_networking_subnet_v2";
    /**
    * Generates CDKTF code for importing a DataOpenstackNetworkingSubnetV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackNetworkingSubnetV2 to import
    * @param importFromId The id of the existing DataOpenstackNetworkingSubnetV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackNetworkingSubnetV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnet_v2 openstack_networking_subnet_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackNetworkingSubnetV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackNetworkingSubnetV2Config);
    get allTags(): string[];
    private _allocationPools;
    get allocationPools(): DataOpenstackNetworkingSubnetV2AllocationPoolsList;
    private _cidr?;
    get cidr(): string;
    set cidr(value: string);
    resetCidr(): void;
    get cidrInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _dhcpEnabled?;
    get dhcpEnabled(): boolean | cdktf.IResolvable;
    set dhcpEnabled(value: boolean | cdktf.IResolvable);
    resetDhcpEnabled(): void;
    get dhcpEnabledInput(): boolean | cdktf.IResolvable | undefined;
    get dnsNameservers(): string[];
    private _dnsPublishFixedIp?;
    get dnsPublishFixedIp(): boolean | cdktf.IResolvable;
    set dnsPublishFixedIp(value: boolean | cdktf.IResolvable);
    resetDnsPublishFixedIp(): void;
    get dnsPublishFixedIpInput(): boolean | cdktf.IResolvable | undefined;
    get enableDhcp(): cdktf.IResolvable;
    private _gatewayIp?;
    get gatewayIp(): string;
    set gatewayIp(value: string);
    resetGatewayIp(): void;
    get gatewayIpInput(): string | undefined;
    private _hostRoutes;
    get hostRoutes(): DataOpenstackNetworkingSubnetV2HostRoutesList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipVersion?;
    get ipVersion(): number;
    set ipVersion(value: number);
    resetIpVersion(): void;
    get ipVersionInput(): number | undefined;
    private _ipv6AddressMode?;
    get ipv6AddressMode(): string;
    set ipv6AddressMode(value: string);
    resetIpv6AddressMode(): void;
    get ipv6AddressModeInput(): string | undefined;
    private _ipv6RaMode?;
    get ipv6RaMode(): string;
    set ipv6RaMode(value: string);
    resetIpv6RaMode(): void;
    get ipv6RaModeInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    resetNetworkId(): void;
    get networkIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get serviceTypes(): string[];
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _subnetpoolId?;
    get subnetpoolId(): string;
    set subnetpoolId(value: string);
    resetSubnetpoolId(): void;
    get subnetpoolIdInput(): string | undefined;
    private _tags?;
    get tags(): string[];
    set tags(value: string[]);
    resetTags(): void;
    get tagsInput(): string[] | undefined;
    private _tenantId?;
    get tenantId(): string;
    set tenantId(value: string);
    resetTenantId(): void;
    get tenantIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
