import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackNetworkingSubnetpoolV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#address_scope_id DataOpenstackNetworkingSubnetpoolV2#address_scope_id}
    */
    readonly addressScopeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#default_prefixlen DataOpenstackNetworkingSubnetpoolV2#default_prefixlen}
    */
    readonly defaultPrefixlen?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#default_quota DataOpenstackNetworkingSubnetpoolV2#default_quota}
    */
    readonly defaultQuota?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#description DataOpenstackNetworkingSubnetpoolV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#id DataOpenstackNetworkingSubnetpoolV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#ip_version DataOpenstackNetworkingSubnetpoolV2#ip_version}
    */
    readonly ipVersion?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#is_default DataOpenstackNetworkingSubnetpoolV2#is_default}
    */
    readonly isDefault?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#max_prefixlen DataOpenstackNetworkingSubnetpoolV2#max_prefixlen}
    */
    readonly maxPrefixlen?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#min_prefixlen DataOpenstackNetworkingSubnetpoolV2#min_prefixlen}
    */
    readonly minPrefixlen?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#name DataOpenstackNetworkingSubnetpoolV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#project_id DataOpenstackNetworkingSubnetpoolV2#project_id}
    */
    readonly projectId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#region DataOpenstackNetworkingSubnetpoolV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#shared DataOpenstackNetworkingSubnetpoolV2#shared}
    */
    readonly shared?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#tags DataOpenstackNetworkingSubnetpoolV2#tags}
    */
    readonly tags?: string[];
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2 openstack_networking_subnetpool_v2}
*/
export declare class DataOpenstackNetworkingSubnetpoolV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_networking_subnetpool_v2";
    /**
    * Generates CDKTF code for importing a DataOpenstackNetworkingSubnetpoolV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackNetworkingSubnetpoolV2 to import
    * @param importFromId The id of the existing DataOpenstackNetworkingSubnetpoolV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackNetworkingSubnetpoolV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/networking_subnetpool_v2 openstack_networking_subnetpool_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackNetworkingSubnetpoolV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackNetworkingSubnetpoolV2Config);
    private _addressScopeId?;
    get addressScopeId(): string;
    set addressScopeId(value: string);
    resetAddressScopeId(): void;
    get addressScopeIdInput(): string | undefined;
    get allTags(): string[];
    get createdAt(): string;
    private _defaultPrefixlen?;
    get defaultPrefixlen(): number;
    set defaultPrefixlen(value: number);
    resetDefaultPrefixlen(): void;
    get defaultPrefixlenInput(): number | undefined;
    private _defaultQuota?;
    get defaultQuota(): number;
    set defaultQuota(value: number);
    resetDefaultQuota(): void;
    get defaultQuotaInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipVersion?;
    get ipVersion(): number;
    set ipVersion(value: number);
    resetIpVersion(): void;
    get ipVersionInput(): number | undefined;
    private _isDefault?;
    get isDefault(): boolean | cdktf.IResolvable;
    set isDefault(value: boolean | cdktf.IResolvable);
    resetIsDefault(): void;
    get isDefaultInput(): boolean | cdktf.IResolvable | undefined;
    private _maxPrefixlen?;
    get maxPrefixlen(): number;
    set maxPrefixlen(value: number);
    resetMaxPrefixlen(): void;
    get maxPrefixlenInput(): number | undefined;
    private _minPrefixlen?;
    get minPrefixlen(): number;
    set minPrefixlen(value: number);
    resetMinPrefixlen(): void;
    get minPrefixlenInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get prefixes(): string[];
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    resetProjectId(): void;
    get projectIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get revisionNumber(): number;
    private _shared?;
    get shared(): boolean | cdktf.IResolvable;
    set shared(value: boolean | cdktf.IResolvable);
    resetShared(): void;
    get sharedInput(): boolean | cdktf.IResolvable | undefined;
    private _tags?;
    get tags(): string[];
    set tags(value: string[]);
    resetTags(): void;
    get tagsInput(): string[] | undefined;
    get updatedAt(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
