import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackSharedfilesystemShareV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#description DataOpenstackSharedfilesystemShareV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#export_location_path DataOpenstackSharedfilesystemShareV2#export_location_path}
    */
    readonly exportLocationPath?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#id DataOpenstackSharedfilesystemShareV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#is_public DataOpenstackSharedfilesystemShareV2#is_public}
    */
    readonly isPublic?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#metadata DataOpenstackSharedfilesystemShareV2#metadata}
    */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#name DataOpenstackSharedfilesystemShareV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#region DataOpenstackSharedfilesystemShareV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#share_network_id DataOpenstackSharedfilesystemShareV2#share_network_id}
    */
    readonly shareNetworkId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#snapshot_id DataOpenstackSharedfilesystemShareV2#snapshot_id}
    */
    readonly snapshotId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#status DataOpenstackSharedfilesystemShareV2#status}
    */
    readonly status?: string;
}
export interface DataOpenstackSharedfilesystemShareV2ExportLocations {
}
export declare function dataOpenstackSharedfilesystemShareV2ExportLocationsToTerraform(struct?: DataOpenstackSharedfilesystemShareV2ExportLocations): any;
export declare function dataOpenstackSharedfilesystemShareV2ExportLocationsToHclTerraform(struct?: DataOpenstackSharedfilesystemShareV2ExportLocations): any;
export declare class DataOpenstackSharedfilesystemShareV2ExportLocationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpenstackSharedfilesystemShareV2ExportLocations | undefined;
    set internalValue(value: DataOpenstackSharedfilesystemShareV2ExportLocations | undefined);
    get path(): string;
    get preferred(): string;
}
export declare class DataOpenstackSharedfilesystemShareV2ExportLocationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpenstackSharedfilesystemShareV2ExportLocationsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2 openstack_sharedfilesystem_share_v2}
*/
export declare class DataOpenstackSharedfilesystemShareV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_sharedfilesystem_share_v2";
    /**
    * Generates CDKTF code for importing a DataOpenstackSharedfilesystemShareV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackSharedfilesystemShareV2 to import
    * @param importFromId The id of the existing DataOpenstackSharedfilesystemShareV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackSharedfilesystemShareV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_share_v2 openstack_sharedfilesystem_share_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackSharedfilesystemShareV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackSharedfilesystemShareV2Config);
    get availabilityZone(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _exportLocationPath?;
    get exportLocationPath(): string;
    set exportLocationPath(value: string);
    resetExportLocationPath(): void;
    get exportLocationPathInput(): string | undefined;
    private _exportLocations;
    get exportLocations(): DataOpenstackSharedfilesystemShareV2ExportLocationsList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _isPublic?;
    get isPublic(): boolean | cdktf.IResolvable;
    set isPublic(value: boolean | cdktf.IResolvable);
    resetIsPublic(): void;
    get isPublicInput(): boolean | cdktf.IResolvable | undefined;
    private _metadata?;
    get metadata(): {
        [key: string]: string;
    };
    set metadata(value: {
        [key: string]: string;
    });
    resetMetadata(): void;
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get projectId(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _shareNetworkId?;
    get shareNetworkId(): string;
    set shareNetworkId(value: string);
    resetShareNetworkId(): void;
    get shareNetworkIdInput(): string | undefined;
    get shareProto(): string;
    get size(): number;
    private _snapshotId?;
    get snapshotId(): string;
    set snapshotId(value: string);
    resetSnapshotId(): void;
    get snapshotIdInput(): string | undefined;
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
