import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackSharedfilesystemSharenetworkV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#description DataOpenstackSharedfilesystemSharenetworkV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#id DataOpenstackSharedfilesystemSharenetworkV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#ip_version DataOpenstackSharedfilesystemSharenetworkV2#ip_version}
    */
    readonly ipVersion?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#name DataOpenstackSharedfilesystemSharenetworkV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#network_type DataOpenstackSharedfilesystemSharenetworkV2#network_type}
    */
    readonly networkType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#neutron_net_id DataOpenstackSharedfilesystemSharenetworkV2#neutron_net_id}
    */
    readonly neutronNetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#neutron_subnet_id DataOpenstackSharedfilesystemSharenetworkV2#neutron_subnet_id}
    */
    readonly neutronSubnetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#region DataOpenstackSharedfilesystemSharenetworkV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#security_service_id DataOpenstackSharedfilesystemSharenetworkV2#security_service_id}
    */
    readonly securityServiceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#segmentation_id DataOpenstackSharedfilesystemSharenetworkV2#segmentation_id}
    */
    readonly segmentationId?: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2 openstack_sharedfilesystem_sharenetwork_v2}
*/
export declare class DataOpenstackSharedfilesystemSharenetworkV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_sharedfilesystem_sharenetwork_v2";
    /**
    * Generates CDKTF code for importing a DataOpenstackSharedfilesystemSharenetworkV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackSharedfilesystemSharenetworkV2 to import
    * @param importFromId The id of the existing DataOpenstackSharedfilesystemSharenetworkV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackSharedfilesystemSharenetworkV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_sharenetwork_v2 openstack_sharedfilesystem_sharenetwork_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackSharedfilesystemSharenetworkV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackSharedfilesystemSharenetworkV2Config);
    get cidr(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipVersion?;
    get ipVersion(): number;
    set ipVersion(value: number);
    resetIpVersion(): void;
    get ipVersionInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _networkType?;
    get networkType(): string;
    set networkType(value: string);
    resetNetworkType(): void;
    get networkTypeInput(): string | undefined;
    private _neutronNetId?;
    get neutronNetId(): string;
    set neutronNetId(value: string);
    resetNeutronNetId(): void;
    get neutronNetIdInput(): string | undefined;
    private _neutronSubnetId?;
    get neutronSubnetId(): string;
    set neutronSubnetId(value: string);
    resetNeutronSubnetId(): void;
    get neutronSubnetIdInput(): string | undefined;
    get projectId(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _securityServiceId?;
    get securityServiceId(): string;
    set securityServiceId(value: string);
    resetSecurityServiceId(): void;
    get securityServiceIdInput(): string | undefined;
    get securityServiceIds(): string[];
    private _segmentationId?;
    get segmentationId(): number;
    set segmentationId(value: number);
    resetSegmentationId(): void;
    get segmentationIdInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
