import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpenstackSharedfilesystemSnapshotV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_snapshot_v2#description DataOpenstackSharedfilesystemSnapshotV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_snapshot_v2#id DataOpenstackSharedfilesystemSnapshotV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_snapshot_v2#name DataOpenstackSharedfilesystemSnapshotV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_snapshot_v2#region DataOpenstackSharedfilesystemSnapshotV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_snapshot_v2#share_id DataOpenstackSharedfilesystemSnapshotV2#share_id}
    */
    readonly shareId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_snapshot_v2#status DataOpenstackSharedfilesystemSnapshotV2#status}
    */
    readonly status?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_snapshot_v2 openstack_sharedfilesystem_snapshot_v2}
*/
export declare class DataOpenstackSharedfilesystemSnapshotV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "openstack_sharedfilesystem_snapshot_v2";
    /**
    * Generates CDKTF code for importing a DataOpenstackSharedfilesystemSnapshotV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpenstackSharedfilesystemSnapshotV2 to import
    * @param importFromId The id of the existing DataOpenstackSharedfilesystemSnapshotV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_snapshot_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpenstackSharedfilesystemSnapshotV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/data-sources/sharedfilesystem_snapshot_v2 openstack_sharedfilesystem_snapshot_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpenstackSharedfilesystemSnapshotV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpenstackSharedfilesystemSnapshotV2Config);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get projectId(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _shareId?;
    get shareId(): string;
    set shareId(value: string);
    resetShareId(): void;
    get shareIdInput(): string | undefined;
    get shareProto(): string;
    get shareSize(): number;
    get size(): number;
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
