import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DbConfigurationV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#description DbConfigurationV1#description}
    */
    readonly description: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#id DbConfigurationV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#name DbConfigurationV1#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#region DbConfigurationV1#region}
    */
    readonly region?: string;
    /**
    * configuration block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#configuration DbConfigurationV1#configuration}
    */
    readonly configuration?: DbConfigurationV1Configuration[] | cdktf.IResolvable;
    /**
    * datastore block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#datastore DbConfigurationV1#datastore}
    */
    readonly datastore: DbConfigurationV1Datastore;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#timeouts DbConfigurationV1#timeouts}
    */
    readonly timeouts?: DbConfigurationV1Timeouts;
}
export interface DbConfigurationV1Configuration {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#name DbConfigurationV1#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#string_type DbConfigurationV1#string_type}
    */
    readonly stringType?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#value DbConfigurationV1#value}
    */
    readonly value: string;
}
export declare function dbConfigurationV1ConfigurationToTerraform(struct?: DbConfigurationV1Configuration | cdktf.IResolvable): any;
export declare function dbConfigurationV1ConfigurationToHclTerraform(struct?: DbConfigurationV1Configuration | cdktf.IResolvable): any;
export declare class DbConfigurationV1ConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DbConfigurationV1Configuration | cdktf.IResolvable | undefined;
    set internalValue(value: DbConfigurationV1Configuration | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _stringType?;
    get stringType(): boolean | cdktf.IResolvable;
    set stringType(value: boolean | cdktf.IResolvable);
    resetStringType(): void;
    get stringTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class DbConfigurationV1ConfigurationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DbConfigurationV1Configuration[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DbConfigurationV1ConfigurationOutputReference;
}
export interface DbConfigurationV1Datastore {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#type DbConfigurationV1#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#version DbConfigurationV1#version}
    */
    readonly version: string;
}
export declare function dbConfigurationV1DatastoreToTerraform(struct?: DbConfigurationV1DatastoreOutputReference | DbConfigurationV1Datastore): any;
export declare function dbConfigurationV1DatastoreToHclTerraform(struct?: DbConfigurationV1DatastoreOutputReference | DbConfigurationV1Datastore): any;
export declare class DbConfigurationV1DatastoreOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DbConfigurationV1Datastore | undefined;
    set internalValue(value: DbConfigurationV1Datastore | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    get versionInput(): string | undefined;
}
export interface DbConfigurationV1Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#create DbConfigurationV1#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#delete DbConfigurationV1#delete}
    */
    readonly delete?: string;
}
export declare function dbConfigurationV1TimeoutsToTerraform(struct?: DbConfigurationV1Timeouts | cdktf.IResolvable): any;
export declare function dbConfigurationV1TimeoutsToHclTerraform(struct?: DbConfigurationV1Timeouts | cdktf.IResolvable): any;
export declare class DbConfigurationV1TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DbConfigurationV1Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DbConfigurationV1Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1 openstack_db_configuration_v1}
*/
export declare class DbConfigurationV1 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_db_configuration_v1";
    /**
    * Generates CDKTF code for importing a DbConfigurationV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DbConfigurationV1 to import
    * @param importFromId The id of the existing DbConfigurationV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DbConfigurationV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/db_configuration_v1 openstack_db_configuration_v1} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DbConfigurationV1Config
    */
    constructor(scope: Construct, id: string, config: DbConfigurationV1Config);
    private _description?;
    get description(): string;
    set description(value: string);
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _configuration;
    get configuration(): DbConfigurationV1ConfigurationList;
    putConfiguration(value: DbConfigurationV1Configuration[] | cdktf.IResolvable): void;
    resetConfiguration(): void;
    get configurationInput(): cdktf.IResolvable | DbConfigurationV1Configuration[] | undefined;
    private _datastore;
    get datastore(): DbConfigurationV1DatastoreOutputReference;
    putDatastore(value: DbConfigurationV1Datastore): void;
    get datastoreInput(): DbConfigurationV1Datastore | undefined;
    private _timeouts;
    get timeouts(): DbConfigurationV1TimeoutsOutputReference;
    putTimeouts(value: DbConfigurationV1Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DbConfigurationV1Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
