import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DnsTransferAcceptV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#disable_status_check DnsTransferAcceptV2#disable_status_check}
    */
    readonly disableStatusCheck?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#id DnsTransferAcceptV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#key DnsTransferAcceptV2#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#region DnsTransferAcceptV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#value_specs DnsTransferAcceptV2#value_specs}
    */
    readonly valueSpecs?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#zone_transfer_request_id DnsTransferAcceptV2#zone_transfer_request_id}
    */
    readonly zoneTransferRequestId: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#timeouts DnsTransferAcceptV2#timeouts}
    */
    readonly timeouts?: DnsTransferAcceptV2Timeouts;
}
export interface DnsTransferAcceptV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#create DnsTransferAcceptV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#delete DnsTransferAcceptV2#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#update DnsTransferAcceptV2#update}
    */
    readonly update?: string;
}
export declare function dnsTransferAcceptV2TimeoutsToTerraform(struct?: DnsTransferAcceptV2Timeouts | cdktf.IResolvable): any;
export declare function dnsTransferAcceptV2TimeoutsToHclTerraform(struct?: DnsTransferAcceptV2Timeouts | cdktf.IResolvable): any;
export declare class DnsTransferAcceptV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DnsTransferAcceptV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DnsTransferAcceptV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2 openstack_dns_transfer_accept_v2}
*/
export declare class DnsTransferAcceptV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_dns_transfer_accept_v2";
    /**
    * Generates CDKTF code for importing a DnsTransferAcceptV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DnsTransferAcceptV2 to import
    * @param importFromId The id of the existing DnsTransferAcceptV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DnsTransferAcceptV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/dns_transfer_accept_v2 openstack_dns_transfer_accept_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DnsTransferAcceptV2Config
    */
    constructor(scope: Construct, id: string, config: DnsTransferAcceptV2Config);
    private _disableStatusCheck?;
    get disableStatusCheck(): boolean | cdktf.IResolvable;
    set disableStatusCheck(value: boolean | cdktf.IResolvable);
    resetDisableStatusCheck(): void;
    get disableStatusCheckInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _valueSpecs?;
    get valueSpecs(): {
        [key: string]: string;
    };
    set valueSpecs(value: {
        [key: string]: string;
    });
    resetValueSpecs(): void;
    get valueSpecsInput(): {
        [key: string]: string;
    } | undefined;
    private _zoneTransferRequestId?;
    get zoneTransferRequestId(): string;
    set zoneTransferRequestId(value: string);
    get zoneTransferRequestIdInput(): string | undefined;
    private _timeouts;
    get timeouts(): DnsTransferAcceptV2TimeoutsOutputReference;
    putTimeouts(value: DnsTransferAcceptV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DnsTransferAcceptV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
