import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IdentityApplicationCredentialV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#description IdentityApplicationCredentialV3#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#expires_at IdentityApplicationCredentialV3#expires_at}
    */
    readonly expiresAt?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#id IdentityApplicationCredentialV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#name IdentityApplicationCredentialV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#region IdentityApplicationCredentialV3#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#roles IdentityApplicationCredentialV3#roles}
    */
    readonly roles?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#secret IdentityApplicationCredentialV3#secret}
    */
    readonly secret?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#unrestricted IdentityApplicationCredentialV3#unrestricted}
    */
    readonly unrestricted?: boolean | cdktf.IResolvable;
    /**
    * access_rules block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#access_rules IdentityApplicationCredentialV3#access_rules}
    */
    readonly accessRules?: IdentityApplicationCredentialV3AccessRules[] | cdktf.IResolvable;
}
export interface IdentityApplicationCredentialV3AccessRules {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#method IdentityApplicationCredentialV3#method}
    */
    readonly method: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#path IdentityApplicationCredentialV3#path}
    */
    readonly path: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#service IdentityApplicationCredentialV3#service}
    */
    readonly service: string;
}
export declare function identityApplicationCredentialV3AccessRulesToTerraform(struct?: IdentityApplicationCredentialV3AccessRules | cdktf.IResolvable): any;
export declare function identityApplicationCredentialV3AccessRulesToHclTerraform(struct?: IdentityApplicationCredentialV3AccessRules | cdktf.IResolvable): any;
export declare class IdentityApplicationCredentialV3AccessRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): IdentityApplicationCredentialV3AccessRules | cdktf.IResolvable | undefined;
    set internalValue(value: IdentityApplicationCredentialV3AccessRules | cdktf.IResolvable | undefined);
    get id(): string;
    private _method?;
    get method(): string;
    set method(value: string);
    get methodInput(): string | undefined;
    private _path?;
    get path(): string;
    set path(value: string);
    get pathInput(): string | undefined;
    private _service?;
    get service(): string;
    set service(value: string);
    get serviceInput(): string | undefined;
}
export declare class IdentityApplicationCredentialV3AccessRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: IdentityApplicationCredentialV3AccessRules[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): IdentityApplicationCredentialV3AccessRulesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3 openstack_identity_application_credential_v3}
*/
export declare class IdentityApplicationCredentialV3 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_identity_application_credential_v3";
    /**
    * Generates CDKTF code for importing a IdentityApplicationCredentialV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the IdentityApplicationCredentialV3 to import
    * @param importFromId The id of the existing IdentityApplicationCredentialV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the IdentityApplicationCredentialV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_application_credential_v3 openstack_identity_application_credential_v3} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IdentityApplicationCredentialV3Config
    */
    constructor(scope: Construct, id: string, config: IdentityApplicationCredentialV3Config);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expiresAt?;
    get expiresAt(): string;
    set expiresAt(value: string);
    resetExpiresAt(): void;
    get expiresAtInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get projectId(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _roles?;
    get roles(): string[];
    set roles(value: string[]);
    resetRoles(): void;
    get rolesInput(): string[] | undefined;
    private _secret?;
    get secret(): string;
    set secret(value: string);
    resetSecret(): void;
    get secretInput(): string | undefined;
    private _unrestricted?;
    get unrestricted(): boolean | cdktf.IResolvable;
    set unrestricted(value: boolean | cdktf.IResolvable);
    resetUnrestricted(): void;
    get unrestrictedInput(): boolean | cdktf.IResolvable | undefined;
    private _accessRules;
    get accessRules(): IdentityApplicationCredentialV3AccessRulesList;
    putAccessRules(value: IdentityApplicationCredentialV3AccessRules[] | cdktf.IResolvable): void;
    resetAccessRules(): void;
    get accessRulesInput(): cdktf.IResolvable | IdentityApplicationCredentialV3AccessRules[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
