import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IdentityUserV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#default_project_id IdentityUserV3#default_project_id}
    */
    readonly defaultProjectId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#description IdentityUserV3#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#domain_id IdentityUserV3#domain_id}
    */
    readonly domainId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#enabled IdentityUserV3#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#extra IdentityUserV3#extra}
    */
    readonly extra?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#id IdentityUserV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#ignore_change_password_upon_first_use IdentityUserV3#ignore_change_password_upon_first_use}
    */
    readonly ignoreChangePasswordUponFirstUse?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#ignore_lockout_failure_attempts IdentityUserV3#ignore_lockout_failure_attempts}
    */
    readonly ignoreLockoutFailureAttempts?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#ignore_password_expiry IdentityUserV3#ignore_password_expiry}
    */
    readonly ignorePasswordExpiry?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#multi_factor_auth_enabled IdentityUserV3#multi_factor_auth_enabled}
    */
    readonly multiFactorAuthEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#name IdentityUserV3#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#password IdentityUserV3#password}
    */
    readonly password?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#region IdentityUserV3#region}
    */
    readonly region?: string;
    /**
    * multi_factor_auth_rule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#multi_factor_auth_rule IdentityUserV3#multi_factor_auth_rule}
    */
    readonly multiFactorAuthRule?: IdentityUserV3MultiFactorAuthRule[] | cdktf.IResolvable;
}
export interface IdentityUserV3MultiFactorAuthRule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#rule IdentityUserV3#rule}
    */
    readonly rule: string[];
}
export declare function identityUserV3MultiFactorAuthRuleToTerraform(struct?: IdentityUserV3MultiFactorAuthRule | cdktf.IResolvable): any;
export declare function identityUserV3MultiFactorAuthRuleToHclTerraform(struct?: IdentityUserV3MultiFactorAuthRule | cdktf.IResolvable): any;
export declare class IdentityUserV3MultiFactorAuthRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): IdentityUserV3MultiFactorAuthRule | cdktf.IResolvable | undefined;
    set internalValue(value: IdentityUserV3MultiFactorAuthRule | cdktf.IResolvable | undefined);
    private _rule?;
    get rule(): string[];
    set rule(value: string[]);
    get ruleInput(): string[] | undefined;
}
export declare class IdentityUserV3MultiFactorAuthRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: IdentityUserV3MultiFactorAuthRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): IdentityUserV3MultiFactorAuthRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3 openstack_identity_user_v3}
*/
export declare class IdentityUserV3 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_identity_user_v3";
    /**
    * Generates CDKTF code for importing a IdentityUserV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the IdentityUserV3 to import
    * @param importFromId The id of the existing IdentityUserV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the IdentityUserV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/identity_user_v3 openstack_identity_user_v3} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IdentityUserV3Config = {}
    */
    constructor(scope: Construct, id: string, config?: IdentityUserV3Config);
    private _defaultProjectId?;
    get defaultProjectId(): string;
    set defaultProjectId(value: string);
    resetDefaultProjectId(): void;
    get defaultProjectIdInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _domainId?;
    get domainId(): string;
    set domainId(value: string);
    resetDomainId(): void;
    get domainIdInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _extra?;
    get extra(): {
        [key: string]: string;
    };
    set extra(value: {
        [key: string]: string;
    });
    resetExtra(): void;
    get extraInput(): {
        [key: string]: string;
    } | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ignoreChangePasswordUponFirstUse?;
    get ignoreChangePasswordUponFirstUse(): boolean | cdktf.IResolvable;
    set ignoreChangePasswordUponFirstUse(value: boolean | cdktf.IResolvable);
    resetIgnoreChangePasswordUponFirstUse(): void;
    get ignoreChangePasswordUponFirstUseInput(): boolean | cdktf.IResolvable | undefined;
    private _ignoreLockoutFailureAttempts?;
    get ignoreLockoutFailureAttempts(): boolean | cdktf.IResolvable;
    set ignoreLockoutFailureAttempts(value: boolean | cdktf.IResolvable);
    resetIgnoreLockoutFailureAttempts(): void;
    get ignoreLockoutFailureAttemptsInput(): boolean | cdktf.IResolvable | undefined;
    private _ignorePasswordExpiry?;
    get ignorePasswordExpiry(): boolean | cdktf.IResolvable;
    set ignorePasswordExpiry(value: boolean | cdktf.IResolvable);
    resetIgnorePasswordExpiry(): void;
    get ignorePasswordExpiryInput(): boolean | cdktf.IResolvable | undefined;
    private _multiFactorAuthEnabled?;
    get multiFactorAuthEnabled(): boolean | cdktf.IResolvable;
    set multiFactorAuthEnabled(value: boolean | cdktf.IResolvable);
    resetMultiFactorAuthEnabled(): void;
    get multiFactorAuthEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _multiFactorAuthRule;
    get multiFactorAuthRule(): IdentityUserV3MultiFactorAuthRuleList;
    putMultiFactorAuthRule(value: IdentityUserV3MultiFactorAuthRule[] | cdktf.IResolvable): void;
    resetMultiFactorAuthRule(): void;
    get multiFactorAuthRuleInput(): cdktf.IResolvable | IdentityUserV3MultiFactorAuthRule[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
