import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface KeymanagerContainerV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#id KeymanagerContainerV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#name KeymanagerContainerV1#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#region KeymanagerContainerV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#type KeymanagerContainerV1#type}
    */
    readonly type: string;
    /**
    * acl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#acl KeymanagerContainerV1#acl}
    */
    readonly acl?: KeymanagerContainerV1Acl;
    /**
    * secret_refs block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#secret_refs KeymanagerContainerV1#secret_refs}
    */
    readonly secretRefs?: KeymanagerContainerV1SecretRefs[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#timeouts KeymanagerContainerV1#timeouts}
    */
    readonly timeouts?: KeymanagerContainerV1Timeouts;
}
export interface KeymanagerContainerV1Consumers {
}
export declare function keymanagerContainerV1ConsumersToTerraform(struct?: KeymanagerContainerV1Consumers): any;
export declare function keymanagerContainerV1ConsumersToHclTerraform(struct?: KeymanagerContainerV1Consumers): any;
export declare class KeymanagerContainerV1ConsumersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): KeymanagerContainerV1Consumers | undefined;
    set internalValue(value: KeymanagerContainerV1Consumers | undefined);
    get name(): string;
    get url(): string;
}
export declare class KeymanagerContainerV1ConsumersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): KeymanagerContainerV1ConsumersOutputReference;
}
export interface KeymanagerContainerV1AclRead {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#project_access KeymanagerContainerV1#project_access}
    */
    readonly projectAccess?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#users KeymanagerContainerV1#users}
    */
    readonly users?: string[];
}
export declare function keymanagerContainerV1AclReadToTerraform(struct?: KeymanagerContainerV1AclReadOutputReference | KeymanagerContainerV1AclRead): any;
export declare function keymanagerContainerV1AclReadToHclTerraform(struct?: KeymanagerContainerV1AclReadOutputReference | KeymanagerContainerV1AclRead): any;
export declare class KeymanagerContainerV1AclReadOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KeymanagerContainerV1AclRead | undefined;
    set internalValue(value: KeymanagerContainerV1AclRead | undefined);
    get createdAt(): string;
    private _projectAccess?;
    get projectAccess(): boolean | cdktf.IResolvable;
    set projectAccess(value: boolean | cdktf.IResolvable);
    resetProjectAccess(): void;
    get projectAccessInput(): boolean | cdktf.IResolvable | undefined;
    get updatedAt(): string;
    private _users?;
    get users(): string[];
    set users(value: string[]);
    resetUsers(): void;
    get usersInput(): string[] | undefined;
}
export interface KeymanagerContainerV1Acl {
    /**
    * read block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#read KeymanagerContainerV1#read}
    */
    readonly read?: KeymanagerContainerV1AclRead;
}
export declare function keymanagerContainerV1AclToTerraform(struct?: KeymanagerContainerV1AclOutputReference | KeymanagerContainerV1Acl): any;
export declare function keymanagerContainerV1AclToHclTerraform(struct?: KeymanagerContainerV1AclOutputReference | KeymanagerContainerV1Acl): any;
export declare class KeymanagerContainerV1AclOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KeymanagerContainerV1Acl | undefined;
    set internalValue(value: KeymanagerContainerV1Acl | undefined);
    private _read;
    get read(): KeymanagerContainerV1AclReadOutputReference;
    putRead(value: KeymanagerContainerV1AclRead): void;
    resetRead(): void;
    get readInput(): KeymanagerContainerV1AclRead | undefined;
}
export interface KeymanagerContainerV1SecretRefs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#name KeymanagerContainerV1#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#secret_ref KeymanagerContainerV1#secret_ref}
    */
    readonly secretRef: string;
}
export declare function keymanagerContainerV1SecretRefsToTerraform(struct?: KeymanagerContainerV1SecretRefs | cdktf.IResolvable): any;
export declare function keymanagerContainerV1SecretRefsToHclTerraform(struct?: KeymanagerContainerV1SecretRefs | cdktf.IResolvable): any;
export declare class KeymanagerContainerV1SecretRefsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): KeymanagerContainerV1SecretRefs | cdktf.IResolvable | undefined;
    set internalValue(value: KeymanagerContainerV1SecretRefs | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _secretRef?;
    get secretRef(): string;
    set secretRef(value: string);
    get secretRefInput(): string | undefined;
}
export declare class KeymanagerContainerV1SecretRefsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: KeymanagerContainerV1SecretRefs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): KeymanagerContainerV1SecretRefsOutputReference;
}
export interface KeymanagerContainerV1Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#create KeymanagerContainerV1#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#delete KeymanagerContainerV1#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#update KeymanagerContainerV1#update}
    */
    readonly update?: string;
}
export declare function keymanagerContainerV1TimeoutsToTerraform(struct?: KeymanagerContainerV1Timeouts | cdktf.IResolvable): any;
export declare function keymanagerContainerV1TimeoutsToHclTerraform(struct?: KeymanagerContainerV1Timeouts | cdktf.IResolvable): any;
export declare class KeymanagerContainerV1TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KeymanagerContainerV1Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: KeymanagerContainerV1Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1 openstack_keymanager_container_v1}
*/
export declare class KeymanagerContainerV1 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_keymanager_container_v1";
    /**
    * Generates CDKTF code for importing a KeymanagerContainerV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the KeymanagerContainerV1 to import
    * @param importFromId The id of the existing KeymanagerContainerV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the KeymanagerContainerV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_container_v1 openstack_keymanager_container_v1} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options KeymanagerContainerV1Config
    */
    constructor(scope: Construct, id: string, config: KeymanagerContainerV1Config);
    private _consumers;
    get consumers(): KeymanagerContainerV1ConsumersList;
    get containerRef(): string;
    get createdAt(): string;
    get creatorId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get status(): string;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    get updatedAt(): string;
    private _acl;
    get acl(): KeymanagerContainerV1AclOutputReference;
    putAcl(value: KeymanagerContainerV1Acl): void;
    resetAcl(): void;
    get aclInput(): KeymanagerContainerV1Acl | undefined;
    private _secretRefs;
    get secretRefs(): KeymanagerContainerV1SecretRefsList;
    putSecretRefs(value: KeymanagerContainerV1SecretRefs[] | cdktf.IResolvable): void;
    resetSecretRefs(): void;
    get secretRefsInput(): cdktf.IResolvable | KeymanagerContainerV1SecretRefs[] | undefined;
    private _timeouts;
    get timeouts(): KeymanagerContainerV1TimeoutsOutputReference;
    putTimeouts(value: KeymanagerContainerV1Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | KeymanagerContainerV1Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
