import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface KeymanagerOrderV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#id KeymanagerOrderV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#region KeymanagerOrderV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#type KeymanagerOrderV1#type}
    */
    readonly type: string;
    /**
    * meta block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#meta KeymanagerOrderV1#meta}
    */
    readonly meta: KeymanagerOrderV1Meta;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#timeouts KeymanagerOrderV1#timeouts}
    */
    readonly timeouts?: KeymanagerOrderV1Timeouts;
}
export interface KeymanagerOrderV1Meta {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#algorithm KeymanagerOrderV1#algorithm}
    */
    readonly algorithm: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#bit_length KeymanagerOrderV1#bit_length}
    */
    readonly bitLength: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#expiration KeymanagerOrderV1#expiration}
    */
    readonly expiration?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#mode KeymanagerOrderV1#mode}
    */
    readonly mode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#name KeymanagerOrderV1#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#payload_content_type KeymanagerOrderV1#payload_content_type}
    */
    readonly payloadContentType?: string;
}
export declare function keymanagerOrderV1MetaToTerraform(struct?: KeymanagerOrderV1MetaOutputReference | KeymanagerOrderV1Meta): any;
export declare function keymanagerOrderV1MetaToHclTerraform(struct?: KeymanagerOrderV1MetaOutputReference | KeymanagerOrderV1Meta): any;
export declare class KeymanagerOrderV1MetaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KeymanagerOrderV1Meta | undefined;
    set internalValue(value: KeymanagerOrderV1Meta | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    get algorithmInput(): string | undefined;
    private _bitLength?;
    get bitLength(): number;
    set bitLength(value: number);
    get bitLengthInput(): number | undefined;
    private _expiration?;
    get expiration(): string;
    set expiration(value: string);
    resetExpiration(): void;
    get expirationInput(): string | undefined;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    resetMode(): void;
    get modeInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _payloadContentType?;
    get payloadContentType(): string;
    set payloadContentType(value: string);
    resetPayloadContentType(): void;
    get payloadContentTypeInput(): string | undefined;
}
export interface KeymanagerOrderV1Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#create KeymanagerOrderV1#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#delete KeymanagerOrderV1#delete}
    */
    readonly delete?: string;
}
export declare function keymanagerOrderV1TimeoutsToTerraform(struct?: KeymanagerOrderV1Timeouts | cdktf.IResolvable): any;
export declare function keymanagerOrderV1TimeoutsToHclTerraform(struct?: KeymanagerOrderV1Timeouts | cdktf.IResolvable): any;
export declare class KeymanagerOrderV1TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KeymanagerOrderV1Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: KeymanagerOrderV1Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1 openstack_keymanager_order_v1}
*/
export declare class KeymanagerOrderV1 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_keymanager_order_v1";
    /**
    * Generates CDKTF code for importing a KeymanagerOrderV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the KeymanagerOrderV1 to import
    * @param importFromId The id of the existing KeymanagerOrderV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the KeymanagerOrderV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_order_v1 openstack_keymanager_order_v1} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options KeymanagerOrderV1Config
    */
    constructor(scope: Construct, id: string, config: KeymanagerOrderV1Config);
    get containerRef(): string;
    get created(): string;
    get creatorId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get orderRef(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get secretRef(): string;
    get status(): string;
    get subStatus(): string;
    get subStatusMessage(): string;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    get updated(): string;
    private _meta;
    get meta(): KeymanagerOrderV1MetaOutputReference;
    putMeta(value: KeymanagerOrderV1Meta): void;
    get metaInput(): KeymanagerOrderV1Meta | undefined;
    private _timeouts;
    get timeouts(): KeymanagerOrderV1TimeoutsOutputReference;
    putTimeouts(value: KeymanagerOrderV1Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | KeymanagerOrderV1Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
