import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface KeymanagerSecretV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#algorithm KeymanagerSecretV1#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#bit_length KeymanagerSecretV1#bit_length}
    */
    readonly bitLength?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#expiration KeymanagerSecretV1#expiration}
    */
    readonly expiration?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#id KeymanagerSecretV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#metadata KeymanagerSecretV1#metadata}
    */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#mode KeymanagerSecretV1#mode}
    */
    readonly mode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#name KeymanagerSecretV1#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#payload KeymanagerSecretV1#payload}
    */
    readonly payload?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#payload_content_encoding KeymanagerSecretV1#payload_content_encoding}
    */
    readonly payloadContentEncoding?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#payload_content_type KeymanagerSecretV1#payload_content_type}
    */
    readonly payloadContentType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#region KeymanagerSecretV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#secret_type KeymanagerSecretV1#secret_type}
    */
    readonly secretType?: string;
    /**
    * acl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#acl KeymanagerSecretV1#acl}
    */
    readonly acl?: KeymanagerSecretV1Acl;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#timeouts KeymanagerSecretV1#timeouts}
    */
    readonly timeouts?: KeymanagerSecretV1Timeouts;
}
export interface KeymanagerSecretV1AclRead {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#project_access KeymanagerSecretV1#project_access}
    */
    readonly projectAccess?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#users KeymanagerSecretV1#users}
    */
    readonly users?: string[];
}
export declare function keymanagerSecretV1AclReadToTerraform(struct?: KeymanagerSecretV1AclReadOutputReference | KeymanagerSecretV1AclRead): any;
export declare function keymanagerSecretV1AclReadToHclTerraform(struct?: KeymanagerSecretV1AclReadOutputReference | KeymanagerSecretV1AclRead): any;
export declare class KeymanagerSecretV1AclReadOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KeymanagerSecretV1AclRead | undefined;
    set internalValue(value: KeymanagerSecretV1AclRead | undefined);
    get createdAt(): string;
    private _projectAccess?;
    get projectAccess(): boolean | cdktf.IResolvable;
    set projectAccess(value: boolean | cdktf.IResolvable);
    resetProjectAccess(): void;
    get projectAccessInput(): boolean | cdktf.IResolvable | undefined;
    get updatedAt(): string;
    private _users?;
    get users(): string[];
    set users(value: string[]);
    resetUsers(): void;
    get usersInput(): string[] | undefined;
}
export interface KeymanagerSecretV1Acl {
    /**
    * read block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#read KeymanagerSecretV1#read}
    */
    readonly read?: KeymanagerSecretV1AclRead;
}
export declare function keymanagerSecretV1AclToTerraform(struct?: KeymanagerSecretV1AclOutputReference | KeymanagerSecretV1Acl): any;
export declare function keymanagerSecretV1AclToHclTerraform(struct?: KeymanagerSecretV1AclOutputReference | KeymanagerSecretV1Acl): any;
export declare class KeymanagerSecretV1AclOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KeymanagerSecretV1Acl | undefined;
    set internalValue(value: KeymanagerSecretV1Acl | undefined);
    private _read;
    get read(): KeymanagerSecretV1AclReadOutputReference;
    putRead(value: KeymanagerSecretV1AclRead): void;
    resetRead(): void;
    get readInput(): KeymanagerSecretV1AclRead | undefined;
}
export interface KeymanagerSecretV1Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#create KeymanagerSecretV1#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#delete KeymanagerSecretV1#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#update KeymanagerSecretV1#update}
    */
    readonly update?: string;
}
export declare function keymanagerSecretV1TimeoutsToTerraform(struct?: KeymanagerSecretV1Timeouts | cdktf.IResolvable): any;
export declare function keymanagerSecretV1TimeoutsToHclTerraform(struct?: KeymanagerSecretV1Timeouts | cdktf.IResolvable): any;
export declare class KeymanagerSecretV1TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KeymanagerSecretV1Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: KeymanagerSecretV1Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1 openstack_keymanager_secret_v1}
*/
export declare class KeymanagerSecretV1 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_keymanager_secret_v1";
    /**
    * Generates CDKTF code for importing a KeymanagerSecretV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the KeymanagerSecretV1 to import
    * @param importFromId The id of the existing KeymanagerSecretV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the KeymanagerSecretV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/keymanager_secret_v1 openstack_keymanager_secret_v1} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options KeymanagerSecretV1Config = {}
    */
    constructor(scope: Construct, id: string, config?: KeymanagerSecretV1Config);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _allMetadata;
    get allMetadata(): cdktf.StringMap;
    private _bitLength?;
    get bitLength(): number;
    set bitLength(value: number);
    resetBitLength(): void;
    get bitLengthInput(): number | undefined;
    private _contentTypes;
    get contentTypes(): cdktf.StringMap;
    get createdAt(): string;
    get creatorId(): string;
    private _expiration?;
    get expiration(): string;
    set expiration(value: string);
    resetExpiration(): void;
    get expirationInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _metadata?;
    get metadata(): {
        [key: string]: string;
    };
    set metadata(value: {
        [key: string]: string;
    });
    resetMetadata(): void;
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    resetMode(): void;
    get modeInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _payload?;
    get payload(): string;
    set payload(value: string);
    resetPayload(): void;
    get payloadInput(): string | undefined;
    private _payloadContentEncoding?;
    get payloadContentEncoding(): string;
    set payloadContentEncoding(value: string);
    resetPayloadContentEncoding(): void;
    get payloadContentEncodingInput(): string | undefined;
    private _payloadContentType?;
    get payloadContentType(): string;
    set payloadContentType(value: string);
    resetPayloadContentType(): void;
    get payloadContentTypeInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get secretRef(): string;
    private _secretType?;
    get secretType(): string;
    set secretType(value: string);
    resetSecretType(): void;
    get secretTypeInput(): string | undefined;
    get status(): string;
    get updatedAt(): string;
    private _acl;
    get acl(): KeymanagerSecretV1AclOutputReference;
    putAcl(value: KeymanagerSecretV1Acl): void;
    resetAcl(): void;
    get aclInput(): KeymanagerSecretV1Acl | undefined;
    private _timeouts;
    get timeouts(): KeymanagerSecretV1TimeoutsOutputReference;
    putTimeouts(value: KeymanagerSecretV1Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | KeymanagerSecretV1Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
