import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface LbFlavorprofileV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2#flavor_data LbFlavorprofileV2#flavor_data}
    */
    readonly flavorData: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2#id LbFlavorprofileV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2#name LbFlavorprofileV2#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2#provider_name LbFlavorprofileV2#provider_name}
    */
    readonly providerName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2#region LbFlavorprofileV2#region}
    */
    readonly region?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2#timeouts LbFlavorprofileV2#timeouts}
    */
    readonly timeouts?: LbFlavorprofileV2Timeouts;
}
export interface LbFlavorprofileV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2#create LbFlavorprofileV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2#delete LbFlavorprofileV2#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2#update LbFlavorprofileV2#update}
    */
    readonly update?: string;
}
export declare function lbFlavorprofileV2TimeoutsToTerraform(struct?: LbFlavorprofileV2Timeouts | cdktf.IResolvable): any;
export declare function lbFlavorprofileV2TimeoutsToHclTerraform(struct?: LbFlavorprofileV2Timeouts | cdktf.IResolvable): any;
export declare class LbFlavorprofileV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbFlavorprofileV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: LbFlavorprofileV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2 openstack_lb_flavorprofile_v2}
*/
export declare class LbFlavorprofileV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_lb_flavorprofile_v2";
    /**
    * Generates CDKTF code for importing a LbFlavorprofileV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the LbFlavorprofileV2 to import
    * @param importFromId The id of the existing LbFlavorprofileV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the LbFlavorprofileV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_flavorprofile_v2 openstack_lb_flavorprofile_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options LbFlavorprofileV2Config
    */
    constructor(scope: Construct, id: string, config: LbFlavorprofileV2Config);
    private _flavorData?;
    get flavorData(): string;
    set flavorData(value: string);
    get flavorDataInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _providerName?;
    get providerName(): string;
    set providerName(value: string);
    get providerNameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _timeouts;
    get timeouts(): LbFlavorprofileV2TimeoutsOutputReference;
    putTimeouts(value: LbFlavorprofileV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | LbFlavorprofileV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
