import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface LbPoolV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#admin_state_up LbPoolV2#admin_state_up}
    */
    readonly adminStateUp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#alpn_protocols LbPoolV2#alpn_protocols}
    */
    readonly alpnProtocols?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#ca_tls_container_ref LbPoolV2#ca_tls_container_ref}
    */
    readonly caTlsContainerRef?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#crl_container_ref LbPoolV2#crl_container_ref}
    */
    readonly crlContainerRef?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#description LbPoolV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#id LbPoolV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#lb_method LbPoolV2#lb_method}
    */
    readonly lbMethod: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#listener_id LbPoolV2#listener_id}
    */
    readonly listenerId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#loadbalancer_id LbPoolV2#loadbalancer_id}
    */
    readonly loadbalancerId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#name LbPoolV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#protocol LbPoolV2#protocol}
    */
    readonly protocol: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#region LbPoolV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#tags LbPoolV2#tags}
    */
    readonly tags?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#tenant_id LbPoolV2#tenant_id}
    */
    readonly tenantId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#tls_ciphers LbPoolV2#tls_ciphers}
    */
    readonly tlsCiphers?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#tls_container_ref LbPoolV2#tls_container_ref}
    */
    readonly tlsContainerRef?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#tls_enabled LbPoolV2#tls_enabled}
    */
    readonly tlsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#tls_versions LbPoolV2#tls_versions}
    */
    readonly tlsVersions?: string[];
    /**
    * persistence block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#persistence LbPoolV2#persistence}
    */
    readonly persistence?: LbPoolV2Persistence;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#timeouts LbPoolV2#timeouts}
    */
    readonly timeouts?: LbPoolV2Timeouts;
}
export interface LbPoolV2Persistence {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#cookie_name LbPoolV2#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#type LbPoolV2#type}
    */
    readonly type: string;
}
export declare function lbPoolV2PersistenceToTerraform(struct?: LbPoolV2PersistenceOutputReference | LbPoolV2Persistence): any;
export declare function lbPoolV2PersistenceToHclTerraform(struct?: LbPoolV2PersistenceOutputReference | LbPoolV2Persistence): any;
export declare class LbPoolV2PersistenceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbPoolV2Persistence | undefined;
    set internalValue(value: LbPoolV2Persistence | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface LbPoolV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#create LbPoolV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#delete LbPoolV2#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#update LbPoolV2#update}
    */
    readonly update?: string;
}
export declare function lbPoolV2TimeoutsToTerraform(struct?: LbPoolV2Timeouts | cdktf.IResolvable): any;
export declare function lbPoolV2TimeoutsToHclTerraform(struct?: LbPoolV2Timeouts | cdktf.IResolvable): any;
export declare class LbPoolV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbPoolV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: LbPoolV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2 openstack_lb_pool_v2}
*/
export declare class LbPoolV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_lb_pool_v2";
    /**
    * Generates CDKTF code for importing a LbPoolV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the LbPoolV2 to import
    * @param importFromId The id of the existing LbPoolV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the LbPoolV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_pool_v2 openstack_lb_pool_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options LbPoolV2Config
    */
    constructor(scope: Construct, id: string, config: LbPoolV2Config);
    private _adminStateUp?;
    get adminStateUp(): boolean | cdktf.IResolvable;
    set adminStateUp(value: boolean | cdktf.IResolvable);
    resetAdminStateUp(): void;
    get adminStateUpInput(): boolean | cdktf.IResolvable | undefined;
    private _alpnProtocols?;
    get alpnProtocols(): string[];
    set alpnProtocols(value: string[]);
    resetAlpnProtocols(): void;
    get alpnProtocolsInput(): string[] | undefined;
    private _caTlsContainerRef?;
    get caTlsContainerRef(): string;
    set caTlsContainerRef(value: string);
    resetCaTlsContainerRef(): void;
    get caTlsContainerRefInput(): string | undefined;
    private _crlContainerRef?;
    get crlContainerRef(): string;
    set crlContainerRef(value: string);
    resetCrlContainerRef(): void;
    get crlContainerRefInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _lbMethod?;
    get lbMethod(): string;
    set lbMethod(value: string);
    get lbMethodInput(): string | undefined;
    private _listenerId?;
    get listenerId(): string;
    set listenerId(value: string);
    resetListenerId(): void;
    get listenerIdInput(): string | undefined;
    private _loadbalancerId?;
    get loadbalancerId(): string;
    set loadbalancerId(value: string);
    resetLoadbalancerId(): void;
    get loadbalancerIdInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    get protocolInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _tags?;
    get tags(): string[];
    set tags(value: string[]);
    resetTags(): void;
    get tagsInput(): string[] | undefined;
    private _tenantId?;
    get tenantId(): string;
    set tenantId(value: string);
    resetTenantId(): void;
    get tenantIdInput(): string | undefined;
    private _tlsCiphers?;
    get tlsCiphers(): string;
    set tlsCiphers(value: string);
    resetTlsCiphers(): void;
    get tlsCiphersInput(): string | undefined;
    private _tlsContainerRef?;
    get tlsContainerRef(): string;
    set tlsContainerRef(value: string);
    resetTlsContainerRef(): void;
    get tlsContainerRefInput(): string | undefined;
    private _tlsEnabled?;
    get tlsEnabled(): boolean | cdktf.IResolvable;
    set tlsEnabled(value: boolean | cdktf.IResolvable);
    resetTlsEnabled(): void;
    get tlsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _tlsVersions?;
    get tlsVersions(): string[];
    set tlsVersions(value: string[]);
    resetTlsVersions(): void;
    get tlsVersionsInput(): string[] | undefined;
    private _persistence;
    get persistence(): LbPoolV2PersistenceOutputReference;
    putPersistence(value: LbPoolV2Persistence): void;
    resetPersistence(): void;
    get persistenceInput(): LbPoolV2Persistence | undefined;
    private _timeouts;
    get timeouts(): LbPoolV2TimeoutsOutputReference;
    putTimeouts(value: LbPoolV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | LbPoolV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
