import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface LbQuotaV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#health_monitor LbQuotaV2#health_monitor}
    */
    readonly healthMonitor?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#id LbQuotaV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#l7_policy LbQuotaV2#l7_policy}
    */
    readonly l7Policy?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#l7_rule LbQuotaV2#l7_rule}
    */
    readonly l7Rule?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#listener LbQuotaV2#listener}
    */
    readonly listener?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#loadbalancer LbQuotaV2#loadbalancer}
    */
    readonly loadbalancer?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#member LbQuotaV2#member}
    */
    readonly member?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#pool LbQuotaV2#pool}
    */
    readonly pool?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#project_id LbQuotaV2#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#region LbQuotaV2#region}
    */
    readonly region?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#timeouts LbQuotaV2#timeouts}
    */
    readonly timeouts?: LbQuotaV2Timeouts;
}
export interface LbQuotaV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#create LbQuotaV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#delete LbQuotaV2#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#update LbQuotaV2#update}
    */
    readonly update?: string;
}
export declare function lbQuotaV2TimeoutsToTerraform(struct?: LbQuotaV2Timeouts | cdktf.IResolvable): any;
export declare function lbQuotaV2TimeoutsToHclTerraform(struct?: LbQuotaV2Timeouts | cdktf.IResolvable): any;
export declare class LbQuotaV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbQuotaV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: LbQuotaV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2 openstack_lb_quota_v2}
*/
export declare class LbQuotaV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_lb_quota_v2";
    /**
    * Generates CDKTF code for importing a LbQuotaV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the LbQuotaV2 to import
    * @param importFromId The id of the existing LbQuotaV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the LbQuotaV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/lb_quota_v2 openstack_lb_quota_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options LbQuotaV2Config
    */
    constructor(scope: Construct, id: string, config: LbQuotaV2Config);
    private _healthMonitor?;
    get healthMonitor(): number;
    set healthMonitor(value: number);
    resetHealthMonitor(): void;
    get healthMonitorInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _l7Policy?;
    get l7Policy(): number;
    set l7Policy(value: number);
    resetL7Policy(): void;
    get l7PolicyInput(): number | undefined;
    private _l7Rule?;
    get l7Rule(): number;
    set l7Rule(value: number);
    resetL7Rule(): void;
    get l7RuleInput(): number | undefined;
    private _listener?;
    get listener(): number;
    set listener(value: number);
    resetListener(): void;
    get listenerInput(): number | undefined;
    private _loadbalancer?;
    get loadbalancer(): number;
    set loadbalancer(value: number);
    resetLoadbalancer(): void;
    get loadbalancerInput(): number | undefined;
    private _member?;
    get member(): number;
    set member(value: number);
    resetMember(): void;
    get memberInput(): number | undefined;
    private _pool?;
    get pool(): number;
    set pool(value: number);
    resetPool(): void;
    get poolInput(): number | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _timeouts;
    get timeouts(): LbQuotaV2TimeoutsOutputReference;
    putTimeouts(value: LbQuotaV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | LbQuotaV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
