import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NetworkingPortforwardingV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#description NetworkingPortforwardingV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#external_port NetworkingPortforwardingV2#external_port}
    */
    readonly externalPort: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#floatingip_id NetworkingPortforwardingV2#floatingip_id}
    */
    readonly floatingipId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#id NetworkingPortforwardingV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#internal_ip_address NetworkingPortforwardingV2#internal_ip_address}
    */
    readonly internalIpAddress: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#internal_port NetworkingPortforwardingV2#internal_port}
    */
    readonly internalPort: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#internal_port_id NetworkingPortforwardingV2#internal_port_id}
    */
    readonly internalPortId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#protocol NetworkingPortforwardingV2#protocol}
    */
    readonly protocol: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#region NetworkingPortforwardingV2#region}
    */
    readonly region?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#timeouts NetworkingPortforwardingV2#timeouts}
    */
    readonly timeouts?: NetworkingPortforwardingV2Timeouts;
}
export interface NetworkingPortforwardingV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#create NetworkingPortforwardingV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#delete NetworkingPortforwardingV2#delete}
    */
    readonly delete?: string;
}
export declare function networkingPortforwardingV2TimeoutsToTerraform(struct?: NetworkingPortforwardingV2Timeouts | cdktf.IResolvable): any;
export declare function networkingPortforwardingV2TimeoutsToHclTerraform(struct?: NetworkingPortforwardingV2Timeouts | cdktf.IResolvable): any;
export declare class NetworkingPortforwardingV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NetworkingPortforwardingV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkingPortforwardingV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2 openstack_networking_portforwarding_v2}
*/
export declare class NetworkingPortforwardingV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_networking_portforwarding_v2";
    /**
    * Generates CDKTF code for importing a NetworkingPortforwardingV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NetworkingPortforwardingV2 to import
    * @param importFromId The id of the existing NetworkingPortforwardingV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NetworkingPortforwardingV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_portforwarding_v2 openstack_networking_portforwarding_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NetworkingPortforwardingV2Config
    */
    constructor(scope: Construct, id: string, config: NetworkingPortforwardingV2Config);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _externalPort?;
    get externalPort(): number;
    set externalPort(value: number);
    get externalPortInput(): number | undefined;
    private _floatingipId?;
    get floatingipId(): string;
    set floatingipId(value: string);
    get floatingipIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _internalIpAddress?;
    get internalIpAddress(): string;
    set internalIpAddress(value: string);
    get internalIpAddressInput(): string | undefined;
    private _internalPort?;
    get internalPort(): number;
    set internalPort(value: number);
    get internalPortInput(): number | undefined;
    private _internalPortId?;
    get internalPortId(): string;
    set internalPortId(value: string);
    get internalPortIdInput(): string | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    get protocolInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _timeouts;
    get timeouts(): NetworkingPortforwardingV2TimeoutsOutputReference;
    putTimeouts(value: NetworkingPortforwardingV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | NetworkingPortforwardingV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
