import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NetworkingQosBandwidthLimitRuleV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2#direction NetworkingQosBandwidthLimitRuleV2#direction}
    */
    readonly direction?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2#id NetworkingQosBandwidthLimitRuleV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2#max_burst_kbps NetworkingQosBandwidthLimitRuleV2#max_burst_kbps}
    */
    readonly maxBurstKbps?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2#max_kbps NetworkingQosBandwidthLimitRuleV2#max_kbps}
    */
    readonly maxKbps: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2#qos_policy_id NetworkingQosBandwidthLimitRuleV2#qos_policy_id}
    */
    readonly qosPolicyId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2#region NetworkingQosBandwidthLimitRuleV2#region}
    */
    readonly region?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2#timeouts NetworkingQosBandwidthLimitRuleV2#timeouts}
    */
    readonly timeouts?: NetworkingQosBandwidthLimitRuleV2Timeouts;
}
export interface NetworkingQosBandwidthLimitRuleV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2#create NetworkingQosBandwidthLimitRuleV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2#delete NetworkingQosBandwidthLimitRuleV2#delete}
    */
    readonly delete?: string;
}
export declare function networkingQosBandwidthLimitRuleV2TimeoutsToTerraform(struct?: NetworkingQosBandwidthLimitRuleV2Timeouts | cdktf.IResolvable): any;
export declare function networkingQosBandwidthLimitRuleV2TimeoutsToHclTerraform(struct?: NetworkingQosBandwidthLimitRuleV2Timeouts | cdktf.IResolvable): any;
export declare class NetworkingQosBandwidthLimitRuleV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NetworkingQosBandwidthLimitRuleV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkingQosBandwidthLimitRuleV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2 openstack_networking_qos_bandwidth_limit_rule_v2}
*/
export declare class NetworkingQosBandwidthLimitRuleV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_networking_qos_bandwidth_limit_rule_v2";
    /**
    * Generates CDKTF code for importing a NetworkingQosBandwidthLimitRuleV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NetworkingQosBandwidthLimitRuleV2 to import
    * @param importFromId The id of the existing NetworkingQosBandwidthLimitRuleV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NetworkingQosBandwidthLimitRuleV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_bandwidth_limit_rule_v2 openstack_networking_qos_bandwidth_limit_rule_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NetworkingQosBandwidthLimitRuleV2Config
    */
    constructor(scope: Construct, id: string, config: NetworkingQosBandwidthLimitRuleV2Config);
    private _direction?;
    get direction(): string;
    set direction(value: string);
    resetDirection(): void;
    get directionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _maxBurstKbps?;
    get maxBurstKbps(): number;
    set maxBurstKbps(value: number);
    resetMaxBurstKbps(): void;
    get maxBurstKbpsInput(): number | undefined;
    private _maxKbps?;
    get maxKbps(): number;
    set maxKbps(value: number);
    get maxKbpsInput(): number | undefined;
    private _qosPolicyId?;
    get qosPolicyId(): string;
    set qosPolicyId(value: string);
    get qosPolicyIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _timeouts;
    get timeouts(): NetworkingQosBandwidthLimitRuleV2TimeoutsOutputReference;
    putTimeouts(value: NetworkingQosBandwidthLimitRuleV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | NetworkingQosBandwidthLimitRuleV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
