import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NetworkingQosDscpMarkingRuleV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_dscp_marking_rule_v2#dscp_mark NetworkingQosDscpMarkingRuleV2#dscp_mark}
    */
    readonly dscpMark: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_dscp_marking_rule_v2#id NetworkingQosDscpMarkingRuleV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_dscp_marking_rule_v2#qos_policy_id NetworkingQosDscpMarkingRuleV2#qos_policy_id}
    */
    readonly qosPolicyId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_dscp_marking_rule_v2#region NetworkingQosDscpMarkingRuleV2#region}
    */
    readonly region?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_dscp_marking_rule_v2#timeouts NetworkingQosDscpMarkingRuleV2#timeouts}
    */
    readonly timeouts?: NetworkingQosDscpMarkingRuleV2Timeouts;
}
export interface NetworkingQosDscpMarkingRuleV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_dscp_marking_rule_v2#create NetworkingQosDscpMarkingRuleV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_dscp_marking_rule_v2#delete NetworkingQosDscpMarkingRuleV2#delete}
    */
    readonly delete?: string;
}
export declare function networkingQosDscpMarkingRuleV2TimeoutsToTerraform(struct?: NetworkingQosDscpMarkingRuleV2Timeouts | cdktf.IResolvable): any;
export declare function networkingQosDscpMarkingRuleV2TimeoutsToHclTerraform(struct?: NetworkingQosDscpMarkingRuleV2Timeouts | cdktf.IResolvable): any;
export declare class NetworkingQosDscpMarkingRuleV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NetworkingQosDscpMarkingRuleV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkingQosDscpMarkingRuleV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_dscp_marking_rule_v2 openstack_networking_qos_dscp_marking_rule_v2}
*/
export declare class NetworkingQosDscpMarkingRuleV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_networking_qos_dscp_marking_rule_v2";
    /**
    * Generates CDKTF code for importing a NetworkingQosDscpMarkingRuleV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NetworkingQosDscpMarkingRuleV2 to import
    * @param importFromId The id of the existing NetworkingQosDscpMarkingRuleV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_dscp_marking_rule_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NetworkingQosDscpMarkingRuleV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_qos_dscp_marking_rule_v2 openstack_networking_qos_dscp_marking_rule_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NetworkingQosDscpMarkingRuleV2Config
    */
    constructor(scope: Construct, id: string, config: NetworkingQosDscpMarkingRuleV2Config);
    private _dscpMark?;
    get dscpMark(): number;
    set dscpMark(value: number);
    get dscpMarkInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _qosPolicyId?;
    get qosPolicyId(): string;
    set qosPolicyId(value: string);
    get qosPolicyIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _timeouts;
    get timeouts(): NetworkingQosDscpMarkingRuleV2TimeoutsOutputReference;
    putTimeouts(value: NetworkingQosDscpMarkingRuleV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | NetworkingQosDscpMarkingRuleV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
