import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NetworkingQuotaV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#floatingip NetworkingQuotaV2#floatingip}
    */
    readonly floatingip?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#id NetworkingQuotaV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#network NetworkingQuotaV2#network}
    */
    readonly network?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#port NetworkingQuotaV2#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#project_id NetworkingQuotaV2#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#rbac_policy NetworkingQuotaV2#rbac_policy}
    */
    readonly rbacPolicy?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#region NetworkingQuotaV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#router NetworkingQuotaV2#router}
    */
    readonly router?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#security_group NetworkingQuotaV2#security_group}
    */
    readonly securityGroup?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#security_group_rule NetworkingQuotaV2#security_group_rule}
    */
    readonly securityGroupRule?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#subnet NetworkingQuotaV2#subnet}
    */
    readonly subnet?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#subnetpool NetworkingQuotaV2#subnetpool}
    */
    readonly subnetpool?: number;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#timeouts NetworkingQuotaV2#timeouts}
    */
    readonly timeouts?: NetworkingQuotaV2Timeouts;
}
export interface NetworkingQuotaV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#create NetworkingQuotaV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#delete NetworkingQuotaV2#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#update NetworkingQuotaV2#update}
    */
    readonly update?: string;
}
export declare function networkingQuotaV2TimeoutsToTerraform(struct?: NetworkingQuotaV2Timeouts | cdktf.IResolvable): any;
export declare function networkingQuotaV2TimeoutsToHclTerraform(struct?: NetworkingQuotaV2Timeouts | cdktf.IResolvable): any;
export declare class NetworkingQuotaV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NetworkingQuotaV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkingQuotaV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2 openstack_networking_quota_v2}
*/
export declare class NetworkingQuotaV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_networking_quota_v2";
    /**
    * Generates CDKTF code for importing a NetworkingQuotaV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NetworkingQuotaV2 to import
    * @param importFromId The id of the existing NetworkingQuotaV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NetworkingQuotaV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_quota_v2 openstack_networking_quota_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NetworkingQuotaV2Config
    */
    constructor(scope: Construct, id: string, config: NetworkingQuotaV2Config);
    private _floatingip?;
    get floatingip(): number;
    set floatingip(value: number);
    resetFloatingip(): void;
    get floatingipInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _network?;
    get network(): number;
    set network(value: number);
    resetNetwork(): void;
    get networkInput(): number | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _rbacPolicy?;
    get rbacPolicy(): number;
    set rbacPolicy(value: number);
    resetRbacPolicy(): void;
    get rbacPolicyInput(): number | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _router?;
    get router(): number;
    set router(value: number);
    resetRouter(): void;
    get routerInput(): number | undefined;
    private _securityGroup?;
    get securityGroup(): number;
    set securityGroup(value: number);
    resetSecurityGroup(): void;
    get securityGroupInput(): number | undefined;
    private _securityGroupRule?;
    get securityGroupRule(): number;
    set securityGroupRule(value: number);
    resetSecurityGroupRule(): void;
    get securityGroupRuleInput(): number | undefined;
    private _subnet?;
    get subnet(): number;
    set subnet(value: number);
    resetSubnet(): void;
    get subnetInput(): number | undefined;
    private _subnetpool?;
    get subnetpool(): number;
    set subnetpool(value: number);
    resetSubnetpool(): void;
    get subnetpoolInput(): number | undefined;
    private _timeouts;
    get timeouts(): NetworkingQuotaV2TimeoutsOutputReference;
    putTimeouts(value: NetworkingQuotaV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | NetworkingQuotaV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
