import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NetworkingRouterV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#admin_state_up NetworkingRouterV2#admin_state_up}
    */
    readonly adminStateUp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#availability_zone_hints NetworkingRouterV2#availability_zone_hints}
    */
    readonly availabilityZoneHints?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#description NetworkingRouterV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#distributed NetworkingRouterV2#distributed}
    */
    readonly distributed?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#enable_snat NetworkingRouterV2#enable_snat}
    */
    readonly enableSnat?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#external_network_id NetworkingRouterV2#external_network_id}
    */
    readonly externalNetworkId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#external_subnet_ids NetworkingRouterV2#external_subnet_ids}
    */
    readonly externalSubnetIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#id NetworkingRouterV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#name NetworkingRouterV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#region NetworkingRouterV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#tags NetworkingRouterV2#tags}
    */
    readonly tags?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#tenant_id NetworkingRouterV2#tenant_id}
    */
    readonly tenantId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#value_specs NetworkingRouterV2#value_specs}
    */
    readonly valueSpecs?: {
        [key: string]: string;
    };
    /**
    * external_fixed_ip block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#external_fixed_ip NetworkingRouterV2#external_fixed_ip}
    */
    readonly externalFixedIp?: NetworkingRouterV2ExternalFixedIp[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#timeouts NetworkingRouterV2#timeouts}
    */
    readonly timeouts?: NetworkingRouterV2Timeouts;
    /**
    * vendor_options block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#vendor_options NetworkingRouterV2#vendor_options}
    */
    readonly vendorOptions?: NetworkingRouterV2VendorOptions;
}
export interface NetworkingRouterV2ExternalFixedIp {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#ip_address NetworkingRouterV2#ip_address}
    */
    readonly ipAddress?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#subnet_id NetworkingRouterV2#subnet_id}
    */
    readonly subnetId?: string;
}
export declare function networkingRouterV2ExternalFixedIpToTerraform(struct?: NetworkingRouterV2ExternalFixedIp | cdktf.IResolvable): any;
export declare function networkingRouterV2ExternalFixedIpToHclTerraform(struct?: NetworkingRouterV2ExternalFixedIp | cdktf.IResolvable): any;
export declare class NetworkingRouterV2ExternalFixedIpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NetworkingRouterV2ExternalFixedIp | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkingRouterV2ExternalFixedIp | cdktf.IResolvable | undefined);
    private _ipAddress?;
    get ipAddress(): string;
    set ipAddress(value: string);
    resetIpAddress(): void;
    get ipAddressInput(): string | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
}
export declare class NetworkingRouterV2ExternalFixedIpList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NetworkingRouterV2ExternalFixedIp[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NetworkingRouterV2ExternalFixedIpOutputReference;
}
export interface NetworkingRouterV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#create NetworkingRouterV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#delete NetworkingRouterV2#delete}
    */
    readonly delete?: string;
}
export declare function networkingRouterV2TimeoutsToTerraform(struct?: NetworkingRouterV2Timeouts | cdktf.IResolvable): any;
export declare function networkingRouterV2TimeoutsToHclTerraform(struct?: NetworkingRouterV2Timeouts | cdktf.IResolvable): any;
export declare class NetworkingRouterV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NetworkingRouterV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkingRouterV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
export interface NetworkingRouterV2VendorOptions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#set_router_gateway_after_create NetworkingRouterV2#set_router_gateway_after_create}
    */
    readonly setRouterGatewayAfterCreate?: boolean | cdktf.IResolvable;
}
export declare function networkingRouterV2VendorOptionsToTerraform(struct?: NetworkingRouterV2VendorOptionsOutputReference | NetworkingRouterV2VendorOptions): any;
export declare function networkingRouterV2VendorOptionsToHclTerraform(struct?: NetworkingRouterV2VendorOptionsOutputReference | NetworkingRouterV2VendorOptions): any;
export declare class NetworkingRouterV2VendorOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NetworkingRouterV2VendorOptions | undefined;
    set internalValue(value: NetworkingRouterV2VendorOptions | undefined);
    private _setRouterGatewayAfterCreate?;
    get setRouterGatewayAfterCreate(): boolean | cdktf.IResolvable;
    set setRouterGatewayAfterCreate(value: boolean | cdktf.IResolvable);
    resetSetRouterGatewayAfterCreate(): void;
    get setRouterGatewayAfterCreateInput(): boolean | cdktf.IResolvable | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2 openstack_networking_router_v2}
*/
export declare class NetworkingRouterV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_networking_router_v2";
    /**
    * Generates CDKTF code for importing a NetworkingRouterV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NetworkingRouterV2 to import
    * @param importFromId The id of the existing NetworkingRouterV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NetworkingRouterV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_router_v2 openstack_networking_router_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NetworkingRouterV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: NetworkingRouterV2Config);
    private _adminStateUp?;
    get adminStateUp(): boolean | cdktf.IResolvable;
    set adminStateUp(value: boolean | cdktf.IResolvable);
    resetAdminStateUp(): void;
    get adminStateUpInput(): boolean | cdktf.IResolvable | undefined;
    get allTags(): string[];
    private _availabilityZoneHints?;
    get availabilityZoneHints(): string[];
    set availabilityZoneHints(value: string[]);
    resetAvailabilityZoneHints(): void;
    get availabilityZoneHintsInput(): string[] | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _distributed?;
    get distributed(): boolean | cdktf.IResolvable;
    set distributed(value: boolean | cdktf.IResolvable);
    resetDistributed(): void;
    get distributedInput(): boolean | cdktf.IResolvable | undefined;
    private _enableSnat?;
    get enableSnat(): boolean | cdktf.IResolvable;
    set enableSnat(value: boolean | cdktf.IResolvable);
    resetEnableSnat(): void;
    get enableSnatInput(): boolean | cdktf.IResolvable | undefined;
    private _externalNetworkId?;
    get externalNetworkId(): string;
    set externalNetworkId(value: string);
    resetExternalNetworkId(): void;
    get externalNetworkIdInput(): string | undefined;
    private _externalSubnetIds?;
    get externalSubnetIds(): string[];
    set externalSubnetIds(value: string[]);
    resetExternalSubnetIds(): void;
    get externalSubnetIdsInput(): string[] | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _tags?;
    get tags(): string[];
    set tags(value: string[]);
    resetTags(): void;
    get tagsInput(): string[] | undefined;
    private _tenantId?;
    get tenantId(): string;
    set tenantId(value: string);
    resetTenantId(): void;
    get tenantIdInput(): string | undefined;
    private _valueSpecs?;
    get valueSpecs(): {
        [key: string]: string;
    };
    set valueSpecs(value: {
        [key: string]: string;
    });
    resetValueSpecs(): void;
    get valueSpecsInput(): {
        [key: string]: string;
    } | undefined;
    private _externalFixedIp;
    get externalFixedIp(): NetworkingRouterV2ExternalFixedIpList;
    putExternalFixedIp(value: NetworkingRouterV2ExternalFixedIp[] | cdktf.IResolvable): void;
    resetExternalFixedIp(): void;
    get externalFixedIpInput(): cdktf.IResolvable | NetworkingRouterV2ExternalFixedIp[] | undefined;
    private _timeouts;
    get timeouts(): NetworkingRouterV2TimeoutsOutputReference;
    putTimeouts(value: NetworkingRouterV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | NetworkingRouterV2Timeouts | undefined;
    private _vendorOptions;
    get vendorOptions(): NetworkingRouterV2VendorOptionsOutputReference;
    putVendorOptions(value: NetworkingRouterV2VendorOptions): void;
    resetVendorOptions(): void;
    get vendorOptionsInput(): NetworkingRouterV2VendorOptions | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
