import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NetworkingTrunkV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#admin_state_up NetworkingTrunkV2#admin_state_up}
    */
    readonly adminStateUp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#description NetworkingTrunkV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#id NetworkingTrunkV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#name NetworkingTrunkV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#port_id NetworkingTrunkV2#port_id}
    */
    readonly portId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#region NetworkingTrunkV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#tags NetworkingTrunkV2#tags}
    */
    readonly tags?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#tenant_id NetworkingTrunkV2#tenant_id}
    */
    readonly tenantId?: string;
    /**
    * sub_port block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#sub_port NetworkingTrunkV2#sub_port}
    */
    readonly subPort?: NetworkingTrunkV2SubPort[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#timeouts NetworkingTrunkV2#timeouts}
    */
    readonly timeouts?: NetworkingTrunkV2Timeouts;
}
export interface NetworkingTrunkV2SubPort {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#port_id NetworkingTrunkV2#port_id}
    */
    readonly portId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#segmentation_id NetworkingTrunkV2#segmentation_id}
    */
    readonly segmentationId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#segmentation_type NetworkingTrunkV2#segmentation_type}
    */
    readonly segmentationType: string;
}
export declare function networkingTrunkV2SubPortToTerraform(struct?: NetworkingTrunkV2SubPort | cdktf.IResolvable): any;
export declare function networkingTrunkV2SubPortToHclTerraform(struct?: NetworkingTrunkV2SubPort | cdktf.IResolvable): any;
export declare class NetworkingTrunkV2SubPortOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NetworkingTrunkV2SubPort | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkingTrunkV2SubPort | cdktf.IResolvable | undefined);
    private _portId?;
    get portId(): string;
    set portId(value: string);
    get portIdInput(): string | undefined;
    private _segmentationId?;
    get segmentationId(): number;
    set segmentationId(value: number);
    get segmentationIdInput(): number | undefined;
    private _segmentationType?;
    get segmentationType(): string;
    set segmentationType(value: string);
    get segmentationTypeInput(): string | undefined;
}
export declare class NetworkingTrunkV2SubPortList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NetworkingTrunkV2SubPort[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NetworkingTrunkV2SubPortOutputReference;
}
export interface NetworkingTrunkV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#create NetworkingTrunkV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#delete NetworkingTrunkV2#delete}
    */
    readonly delete?: string;
}
export declare function networkingTrunkV2TimeoutsToTerraform(struct?: NetworkingTrunkV2Timeouts | cdktf.IResolvable): any;
export declare function networkingTrunkV2TimeoutsToHclTerraform(struct?: NetworkingTrunkV2Timeouts | cdktf.IResolvable): any;
export declare class NetworkingTrunkV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NetworkingTrunkV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkingTrunkV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2 openstack_networking_trunk_v2}
*/
export declare class NetworkingTrunkV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_networking_trunk_v2";
    /**
    * Generates CDKTF code for importing a NetworkingTrunkV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NetworkingTrunkV2 to import
    * @param importFromId The id of the existing NetworkingTrunkV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NetworkingTrunkV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/networking_trunk_v2 openstack_networking_trunk_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NetworkingTrunkV2Config
    */
    constructor(scope: Construct, id: string, config: NetworkingTrunkV2Config);
    private _adminStateUp?;
    get adminStateUp(): boolean | cdktf.IResolvable;
    set adminStateUp(value: boolean | cdktf.IResolvable);
    resetAdminStateUp(): void;
    get adminStateUpInput(): boolean | cdktf.IResolvable | undefined;
    get allTags(): string[];
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _portId?;
    get portId(): string;
    set portId(value: string);
    get portIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _tags?;
    get tags(): string[];
    set tags(value: string[]);
    resetTags(): void;
    get tagsInput(): string[] | undefined;
    private _tenantId?;
    get tenantId(): string;
    set tenantId(value: string);
    resetTenantId(): void;
    get tenantIdInput(): string | undefined;
    private _subPort;
    get subPort(): NetworkingTrunkV2SubPortList;
    putSubPort(value: NetworkingTrunkV2SubPort[] | cdktf.IResolvable): void;
    resetSubPort(): void;
    get subPortInput(): cdktf.IResolvable | NetworkingTrunkV2SubPort[] | undefined;
    private _timeouts;
    get timeouts(): NetworkingTrunkV2TimeoutsOutputReference;
    putTimeouts(value: NetworkingTrunkV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | NetworkingTrunkV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
