import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ObjectstorageContainerV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#container_read ObjectstorageContainerV1#container_read}
    */
    readonly containerRead?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#container_sync_key ObjectstorageContainerV1#container_sync_key}
    */
    readonly containerSyncKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#container_sync_to ObjectstorageContainerV1#container_sync_to}
    */
    readonly containerSyncTo?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#container_write ObjectstorageContainerV1#container_write}
    */
    readonly containerWrite?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#content_type ObjectstorageContainerV1#content_type}
    */
    readonly contentType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#force_destroy ObjectstorageContainerV1#force_destroy}
    */
    readonly forceDestroy?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#id ObjectstorageContainerV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#metadata ObjectstorageContainerV1#metadata}
    */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#name ObjectstorageContainerV1#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#region ObjectstorageContainerV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#storage_policy ObjectstorageContainerV1#storage_policy}
    */
    readonly storagePolicy?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#versioning ObjectstorageContainerV1#versioning}
    */
    readonly versioning?: boolean | cdktf.IResolvable;
    /**
    * versioning_legacy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#versioning_legacy ObjectstorageContainerV1#versioning_legacy}
    */
    readonly versioningLegacy?: ObjectstorageContainerV1VersioningLegacy;
}
export interface ObjectstorageContainerV1VersioningLegacy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#location ObjectstorageContainerV1#location}
    */
    readonly location: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#type ObjectstorageContainerV1#type}
    */
    readonly type: string;
}
export declare function objectstorageContainerV1VersioningLegacyToTerraform(struct?: ObjectstorageContainerV1VersioningLegacyOutputReference | ObjectstorageContainerV1VersioningLegacy): any;
export declare function objectstorageContainerV1VersioningLegacyToHclTerraform(struct?: ObjectstorageContainerV1VersioningLegacyOutputReference | ObjectstorageContainerV1VersioningLegacy): any;
export declare class ObjectstorageContainerV1VersioningLegacyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ObjectstorageContainerV1VersioningLegacy | undefined;
    set internalValue(value: ObjectstorageContainerV1VersioningLegacy | undefined);
    private _location?;
    get location(): string;
    set location(value: string);
    get locationInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1 openstack_objectstorage_container_v1}
*/
export declare class ObjectstorageContainerV1 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_objectstorage_container_v1";
    /**
    * Generates CDKTF code for importing a ObjectstorageContainerV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ObjectstorageContainerV1 to import
    * @param importFromId The id of the existing ObjectstorageContainerV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ObjectstorageContainerV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/objectstorage_container_v1 openstack_objectstorage_container_v1} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ObjectstorageContainerV1Config
    */
    constructor(scope: Construct, id: string, config: ObjectstorageContainerV1Config);
    private _containerRead?;
    get containerRead(): string;
    set containerRead(value: string);
    resetContainerRead(): void;
    get containerReadInput(): string | undefined;
    private _containerSyncKey?;
    get containerSyncKey(): string;
    set containerSyncKey(value: string);
    resetContainerSyncKey(): void;
    get containerSyncKeyInput(): string | undefined;
    private _containerSyncTo?;
    get containerSyncTo(): string;
    set containerSyncTo(value: string);
    resetContainerSyncTo(): void;
    get containerSyncToInput(): string | undefined;
    private _containerWrite?;
    get containerWrite(): string;
    set containerWrite(value: string);
    resetContainerWrite(): void;
    get containerWriteInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _forceDestroy?;
    get forceDestroy(): boolean | cdktf.IResolvable;
    set forceDestroy(value: boolean | cdktf.IResolvable);
    resetForceDestroy(): void;
    get forceDestroyInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _metadata?;
    get metadata(): {
        [key: string]: string;
    };
    set metadata(value: {
        [key: string]: string;
    });
    resetMetadata(): void;
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _storagePolicy?;
    get storagePolicy(): string;
    set storagePolicy(value: string);
    resetStoragePolicy(): void;
    get storagePolicyInput(): string | undefined;
    private _versioning?;
    get versioning(): boolean | cdktf.IResolvable;
    set versioning(value: boolean | cdktf.IResolvable);
    resetVersioning(): void;
    get versioningInput(): boolean | cdktf.IResolvable | undefined;
    private _versioningLegacy;
    get versioningLegacy(): ObjectstorageContainerV1VersioningLegacyOutputReference;
    putVersioningLegacy(value: ObjectstorageContainerV1VersioningLegacy): void;
    resetVersioningLegacy(): void;
    get versioningLegacyInput(): ObjectstorageContainerV1VersioningLegacy | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
