import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OrchestrationStackV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#capabilities OrchestrationStackV1#capabilities}
    */
    readonly capabilities?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#creation_time OrchestrationStackV1#creation_time}
    */
    readonly creationTime?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#description OrchestrationStackV1#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#disable_rollback OrchestrationStackV1#disable_rollback}
    */
    readonly disableRollback?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#environment_opts OrchestrationStackV1#environment_opts}
    */
    readonly environmentOpts?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#id OrchestrationStackV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#name OrchestrationStackV1#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#notification_topics OrchestrationStackV1#notification_topics}
    */
    readonly notificationTopics?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#parameters OrchestrationStackV1#parameters}
    */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#region OrchestrationStackV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#status OrchestrationStackV1#status}
    */
    readonly status?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#status_reason OrchestrationStackV1#status_reason}
    */
    readonly statusReason?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#tags OrchestrationStackV1#tags}
    */
    readonly tags?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#template_description OrchestrationStackV1#template_description}
    */
    readonly templateDescription?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#template_opts OrchestrationStackV1#template_opts}
    */
    readonly templateOpts: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#timeout OrchestrationStackV1#timeout}
    */
    readonly timeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#updated_time OrchestrationStackV1#updated_time}
    */
    readonly updatedTime?: string;
    /**
    * outputs block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#outputs OrchestrationStackV1#outputs}
    */
    readonly outputs?: OrchestrationStackV1Outputs[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#timeouts OrchestrationStackV1#timeouts}
    */
    readonly timeouts?: OrchestrationStackV1Timeouts;
}
export interface OrchestrationStackV1Outputs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#description OrchestrationStackV1#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#output_key OrchestrationStackV1#output_key}
    */
    readonly outputKey: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#output_value OrchestrationStackV1#output_value}
    */
    readonly outputValue: string;
}
export declare function orchestrationStackV1OutputsToTerraform(struct?: OrchestrationStackV1Outputs | cdktf.IResolvable): any;
export declare function orchestrationStackV1OutputsToHclTerraform(struct?: OrchestrationStackV1Outputs | cdktf.IResolvable): any;
export declare class OrchestrationStackV1OutputsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OrchestrationStackV1Outputs | cdktf.IResolvable | undefined;
    set internalValue(value: OrchestrationStackV1Outputs | cdktf.IResolvable | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _outputKey?;
    get outputKey(): string;
    set outputKey(value: string);
    get outputKeyInput(): string | undefined;
    private _outputValue?;
    get outputValue(): string;
    set outputValue(value: string);
    get outputValueInput(): string | undefined;
}
export declare class OrchestrationStackV1OutputsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OrchestrationStackV1Outputs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OrchestrationStackV1OutputsOutputReference;
}
export interface OrchestrationStackV1Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#create OrchestrationStackV1#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#delete OrchestrationStackV1#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#update OrchestrationStackV1#update}
    */
    readonly update?: string;
}
export declare function orchestrationStackV1TimeoutsToTerraform(struct?: OrchestrationStackV1Timeouts | cdktf.IResolvable): any;
export declare function orchestrationStackV1TimeoutsToHclTerraform(struct?: OrchestrationStackV1Timeouts | cdktf.IResolvable): any;
export declare class OrchestrationStackV1TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OrchestrationStackV1Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: OrchestrationStackV1Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1 openstack_orchestration_stack_v1}
*/
export declare class OrchestrationStackV1 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_orchestration_stack_v1";
    /**
    * Generates CDKTF code for importing a OrchestrationStackV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OrchestrationStackV1 to import
    * @param importFromId The id of the existing OrchestrationStackV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OrchestrationStackV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/orchestration_stack_v1 openstack_orchestration_stack_v1} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OrchestrationStackV1Config
    */
    constructor(scope: Construct, id: string, config: OrchestrationStackV1Config);
    private _capabilities?;
    get capabilities(): string[];
    set capabilities(value: string[]);
    resetCapabilities(): void;
    get capabilitiesInput(): string[] | undefined;
    private _creationTime?;
    get creationTime(): string;
    set creationTime(value: string);
    resetCreationTime(): void;
    get creationTimeInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _disableRollback?;
    get disableRollback(): boolean | cdktf.IResolvable;
    set disableRollback(value: boolean | cdktf.IResolvable);
    resetDisableRollback(): void;
    get disableRollbackInput(): boolean | cdktf.IResolvable | undefined;
    private _environmentOpts?;
    get environmentOpts(): {
        [key: string]: string;
    };
    set environmentOpts(value: {
        [key: string]: string;
    });
    resetEnvironmentOpts(): void;
    get environmentOptsInput(): {
        [key: string]: string;
    } | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _notificationTopics?;
    get notificationTopics(): string[];
    set notificationTopics(value: string[]);
    resetNotificationTopics(): void;
    get notificationTopicsInput(): string[] | undefined;
    private _parameters?;
    get parameters(): {
        [key: string]: string;
    };
    set parameters(value: {
        [key: string]: string;
    });
    resetParameters(): void;
    get parametersInput(): {
        [key: string]: string;
    } | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
    private _statusReason?;
    get statusReason(): string;
    set statusReason(value: string);
    resetStatusReason(): void;
    get statusReasonInput(): string | undefined;
    private _tags?;
    get tags(): string[];
    set tags(value: string[]);
    resetTags(): void;
    get tagsInput(): string[] | undefined;
    private _templateDescription?;
    get templateDescription(): string;
    set templateDescription(value: string);
    resetTemplateDescription(): void;
    get templateDescriptionInput(): string | undefined;
    private _templateOpts?;
    get templateOpts(): {
        [key: string]: string;
    };
    set templateOpts(value: {
        [key: string]: string;
    });
    get templateOptsInput(): {
        [key: string]: string;
    } | undefined;
    private _timeout?;
    get timeout(): number;
    set timeout(value: number);
    resetTimeout(): void;
    get timeoutInput(): number | undefined;
    private _updatedTime?;
    get updatedTime(): string;
    set updatedTime(value: string);
    resetUpdatedTime(): void;
    get updatedTimeInput(): string | undefined;
    private _outputs;
    get outputs(): OrchestrationStackV1OutputsList;
    putOutputs(value: OrchestrationStackV1Outputs[] | cdktf.IResolvable): void;
    resetOutputs(): void;
    get outputsInput(): cdktf.IResolvable | OrchestrationStackV1Outputs[] | undefined;
    private _timeouts;
    get timeouts(): OrchestrationStackV1TimeoutsOutputReference;
    putTimeouts(value: OrchestrationStackV1Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | OrchestrationStackV1Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
