import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface SharedfilesystemSecurityserviceV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#description SharedfilesystemSecurityserviceV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#dns_ip SharedfilesystemSecurityserviceV2#dns_ip}
    */
    readonly dnsIp?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#domain SharedfilesystemSecurityserviceV2#domain}
    */
    readonly domain?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#id SharedfilesystemSecurityserviceV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#name SharedfilesystemSecurityserviceV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#ou SharedfilesystemSecurityserviceV2#ou}
    */
    readonly ou?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#password SharedfilesystemSecurityserviceV2#password}
    */
    readonly password?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#region SharedfilesystemSecurityserviceV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#server SharedfilesystemSecurityserviceV2#server}
    */
    readonly server?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#type SharedfilesystemSecurityserviceV2#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#user SharedfilesystemSecurityserviceV2#user}
    */
    readonly user?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#timeouts SharedfilesystemSecurityserviceV2#timeouts}
    */
    readonly timeouts?: SharedfilesystemSecurityserviceV2Timeouts;
}
export interface SharedfilesystemSecurityserviceV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#create SharedfilesystemSecurityserviceV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#delete SharedfilesystemSecurityserviceV2#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#update SharedfilesystemSecurityserviceV2#update}
    */
    readonly update?: string;
}
export declare function sharedfilesystemSecurityserviceV2TimeoutsToTerraform(struct?: SharedfilesystemSecurityserviceV2Timeouts | cdktf.IResolvable): any;
export declare function sharedfilesystemSecurityserviceV2TimeoutsToHclTerraform(struct?: SharedfilesystemSecurityserviceV2Timeouts | cdktf.IResolvable): any;
export declare class SharedfilesystemSecurityserviceV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): SharedfilesystemSecurityserviceV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: SharedfilesystemSecurityserviceV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2 openstack_sharedfilesystem_securityservice_v2}
*/
export declare class SharedfilesystemSecurityserviceV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_sharedfilesystem_securityservice_v2";
    /**
    * Generates CDKTF code for importing a SharedfilesystemSecurityserviceV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the SharedfilesystemSecurityserviceV2 to import
    * @param importFromId The id of the existing SharedfilesystemSecurityserviceV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the SharedfilesystemSecurityserviceV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_securityservice_v2 openstack_sharedfilesystem_securityservice_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options SharedfilesystemSecurityserviceV2Config
    */
    constructor(scope: Construct, id: string, config: SharedfilesystemSecurityserviceV2Config);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _dnsIp?;
    get dnsIp(): string;
    set dnsIp(value: string);
    resetDnsIp(): void;
    get dnsIpInput(): string | undefined;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    resetDomain(): void;
    get domainInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _ou?;
    get ou(): string;
    set ou(value: string);
    resetOu(): void;
    get ouInput(): string | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    get projectId(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _server?;
    get server(): string;
    set server(value: string);
    resetServer(): void;
    get serverInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _timeouts;
    get timeouts(): SharedfilesystemSecurityserviceV2TimeoutsOutputReference;
    putTimeouts(value: SharedfilesystemSecurityserviceV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | SharedfilesystemSecurityserviceV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
