import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface SharedfilesystemShareAccessV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#access_level SharedfilesystemShareAccessV2#access_level}
    */
    readonly accessLevel: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#access_to SharedfilesystemShareAccessV2#access_to}
    */
    readonly accessTo: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#access_type SharedfilesystemShareAccessV2#access_type}
    */
    readonly accessType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#id SharedfilesystemShareAccessV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#region SharedfilesystemShareAccessV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#share_id SharedfilesystemShareAccessV2#share_id}
    */
    readonly shareId: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#timeouts SharedfilesystemShareAccessV2#timeouts}
    */
    readonly timeouts?: SharedfilesystemShareAccessV2Timeouts;
}
export interface SharedfilesystemShareAccessV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#create SharedfilesystemShareAccessV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#delete SharedfilesystemShareAccessV2#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#update SharedfilesystemShareAccessV2#update}
    */
    readonly update?: string;
}
export declare function sharedfilesystemShareAccessV2TimeoutsToTerraform(struct?: SharedfilesystemShareAccessV2Timeouts | cdktf.IResolvable): any;
export declare function sharedfilesystemShareAccessV2TimeoutsToHclTerraform(struct?: SharedfilesystemShareAccessV2Timeouts | cdktf.IResolvable): any;
export declare class SharedfilesystemShareAccessV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): SharedfilesystemShareAccessV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: SharedfilesystemShareAccessV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2 openstack_sharedfilesystem_share_access_v2}
*/
export declare class SharedfilesystemShareAccessV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_sharedfilesystem_share_access_v2";
    /**
    * Generates CDKTF code for importing a SharedfilesystemShareAccessV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the SharedfilesystemShareAccessV2 to import
    * @param importFromId The id of the existing SharedfilesystemShareAccessV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the SharedfilesystemShareAccessV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_share_access_v2 openstack_sharedfilesystem_share_access_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options SharedfilesystemShareAccessV2Config
    */
    constructor(scope: Construct, id: string, config: SharedfilesystemShareAccessV2Config);
    get accessKey(): string;
    private _accessLevel?;
    get accessLevel(): string;
    set accessLevel(value: string);
    get accessLevelInput(): string | undefined;
    private _accessTo?;
    get accessTo(): string;
    set accessTo(value: string);
    get accessToInput(): string | undefined;
    private _accessType?;
    get accessType(): string;
    set accessType(value: string);
    get accessTypeInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _shareId?;
    get shareId(): string;
    set shareId(value: string);
    get shareIdInput(): string | undefined;
    get state(): string;
    private _timeouts;
    get timeouts(): SharedfilesystemShareAccessV2TimeoutsOutputReference;
    putTimeouts(value: SharedfilesystemShareAccessV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | SharedfilesystemShareAccessV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
