import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface SharedfilesystemSharenetworkV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#description SharedfilesystemSharenetworkV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#id SharedfilesystemSharenetworkV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#name SharedfilesystemSharenetworkV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#neutron_net_id SharedfilesystemSharenetworkV2#neutron_net_id}
    */
    readonly neutronNetId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#neutron_subnet_id SharedfilesystemSharenetworkV2#neutron_subnet_id}
    */
    readonly neutronSubnetId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#region SharedfilesystemSharenetworkV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#security_service_ids SharedfilesystemSharenetworkV2#security_service_ids}
    */
    readonly securityServiceIds?: string[];
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#timeouts SharedfilesystemSharenetworkV2#timeouts}
    */
    readonly timeouts?: SharedfilesystemSharenetworkV2Timeouts;
}
export interface SharedfilesystemSharenetworkV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#create SharedfilesystemSharenetworkV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#delete SharedfilesystemSharenetworkV2#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#update SharedfilesystemSharenetworkV2#update}
    */
    readonly update?: string;
}
export declare function sharedfilesystemSharenetworkV2TimeoutsToTerraform(struct?: SharedfilesystemSharenetworkV2Timeouts | cdktf.IResolvable): any;
export declare function sharedfilesystemSharenetworkV2TimeoutsToHclTerraform(struct?: SharedfilesystemSharenetworkV2Timeouts | cdktf.IResolvable): any;
export declare class SharedfilesystemSharenetworkV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): SharedfilesystemSharenetworkV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: SharedfilesystemSharenetworkV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2 openstack_sharedfilesystem_sharenetwork_v2}
*/
export declare class SharedfilesystemSharenetworkV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_sharedfilesystem_sharenetwork_v2";
    /**
    * Generates CDKTF code for importing a SharedfilesystemSharenetworkV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the SharedfilesystemSharenetworkV2 to import
    * @param importFromId The id of the existing SharedfilesystemSharenetworkV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the SharedfilesystemSharenetworkV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/3.0.0/docs/resources/sharedfilesystem_sharenetwork_v2 openstack_sharedfilesystem_sharenetwork_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options SharedfilesystemSharenetworkV2Config
    */
    constructor(scope: Construct, id: string, config: SharedfilesystemSharenetworkV2Config);
    get cidr(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ipVersion(): number;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkType(): string;
    private _neutronNetId?;
    get neutronNetId(): string;
    set neutronNetId(value: string);
    get neutronNetIdInput(): string | undefined;
    private _neutronSubnetId?;
    get neutronSubnetId(): string;
    set neutronSubnetId(value: string);
    get neutronSubnetIdInput(): string | undefined;
    get projectId(): string;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _securityServiceIds?;
    get securityServiceIds(): string[];
    set securityServiceIds(value: string[]);
    resetSecurityServiceIds(): void;
    get securityServiceIdsInput(): string[] | undefined;
    get segmentationId(): number;
    private _timeouts;
    get timeouts(): SharedfilesystemSharenetworkV2TimeoutsOutputReference;
    putTimeouts(value: SharedfilesystemSharenetworkV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | SharedfilesystemSharenetworkV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
